package com.seeyon.apps.govdoc.manager;

import com.seeyon.apps.govdoc.po.GovdocLeaderPermissionRelation;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.permission.bo.Permission;
import com.seeyon.ctp.common.permission.vo.PermissionVO;
import com.seeyon.ctp.util.FlipInfo;

import java.util.List;
import java.util.Map;

public interface GovdocLeaderAndPermissionRelationManager {
    public FlipInfo findLeaderAndPermissionRelation(FlipInfo flipInfo, Map params ) throws BusinessException;
    public FlipInfo findById(FlipInfo flipInfo, Map params ) throws BusinessException;
    public String LeaderIdStrTransName(String str) throws BusinessException;
    public String permissionIdStrTransName(String str) throws BusinessException;
    public int checkNew(Object object1,Object object2) throws BusinessException;
    public int check(Object object1,Object object2,Object object3) throws BusinessException;
    public boolean deleteLPRByLeaderId(String leaderId,Long orgAccountId,int category) throws BusinessException;
    public boolean deleteLPRByLeaderNewId(String leaderId,Long orgAccountId) throws BusinessException;
    public void saveOrEdit(GovdocLeaderPermissionRelation govdocLPR) throws BusinessException;
    public void deleteList(String ids)  throws BusinessException;
    
    public List<PermissionVO> getPermissionList(String leaderId,String accountId,String govdocType) throws BusinessException;
    
    public GovdocLeaderPermissionRelation getById(Long id) throws BusinessException;
}
