package com.seeyon.apps.govdoc.manager;

import com.seeyon.apps.govdoc.po.PishiDeal;
import com.seeyon.apps.govdoc.vo.GovdocPishiVO;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.util.annotation.AjaxAccess;

import java.util.List;
import java.util.Map;

public interface GovdocTransInstructionManager {
    @AjaxAccess
    public List<PishiDeal> getPishiList(long edocId);

    /**
     * 获取领导批示编号信息
     * @param memberId
     * @return
     * @throws BusinessException
     */
    @AjaxAccess
    public GovdocPishiVO getPishiNo(Long memberId) throws BusinessException;
    /**
     * 保存代录批示
     * @param param
     * @return 成功：success，失败：errorMessage
     * @throws BusinessException
     */
    @AjaxAccess
    public Map<String, Object> saveLeaderInput(List<Map<String,String>> param, Long summaryId, Long affairId) throws BusinessException;
    
    /**
     * 删除代录批示
     * @param param
     * @return 成功：success，失败：errorMessage
     * @throws BusinessException
     */
    @AjaxAccess
    public String deleteLeaderInput(Long id) throws BusinessException;
       
    public String savePishiDealInfo(List<Map<String,String>> param,Long summaryId,List<String> affairIds,Map<String,String> affairIdMap) throws BusinessException;
    
    public void dealLeaderNode(Long summaryId,Long userId) throws BusinessException;
    /**
     * 获取对应领导的兼职单位
     * @param memberId
     * @return
     * @throws BusinessException
     */
    @AjaxAccess
    public Map<String,Object> getPostByMemberId(Long memberId) throws BusinessException;
    
    @AjaxAccess
    public void deleteOpinion(List<String> affairIds,List<Map<String,String>> param,Long summaryId) throws BusinessException;
    
    @AjaxAccess
    public List<PishiDeal> getDealList(Long summaryId) throws BusinessException;
}
