package com.seeyon.apps.govdoc.manager.external;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.logging.Log;

import com.seeyon.apps.collaboration.enums.CommentExtAtt1Enum;
import com.seeyon.apps.edoc.bo.EdocSummaryBO;
import com.seeyon.apps.govdoc.bo.GovdocLockObject;
import com.seeyon.apps.govdoc.dao.GovdocPishiDao;
import com.seeyon.apps.govdoc.helper.GovdocContentHelper;
import com.seeyon.apps.govdoc.helper.GovdocNewHelper;
import com.seeyon.apps.govdoc.manager.GovdocExchangeManager;
import com.seeyon.apps.govdoc.manager.GovdocFormManager;
import com.seeyon.apps.govdoc.manager.GovdocLockManager;
import com.seeyon.apps.govdoc.manager.GovdocManager;
import com.seeyon.apps.govdoc.manager.GovdocPishiManager;
import com.seeyon.apps.govdoc.manager.GovdocPubManager;
import com.seeyon.apps.govdoc.manager.GovdocSummaryManager;
import com.seeyon.apps.govdoc.mark.manager.GovdocMarkManager;
import com.seeyon.apps.govdoc.mark.manager.GovdocMarkOpenManager;
import com.seeyon.apps.govdoc.vo.GovdocDealVO;
import com.seeyon.apps.govdoc.vo.GovdocRepealVO;
import com.seeyon.ctp.cap.api.manager.CAPFormManager;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.batch.bo.BatchCheckResult;
import com.seeyon.ctp.common.batch.bo.BatchResult;
import com.seeyon.ctp.common.batch.bo.BatchState;
import com.seeyon.ctp.common.batch.bo.FinishResult;
import com.seeyon.ctp.common.batch.exception.BatchException;
import com.seeyon.ctp.common.batch.manager.BatchAppHandler;
import com.seeyon.ctp.common.constants.ApplicationCategoryEnum;
import com.seeyon.ctp.common.constants.ApplicationSubCategoryEnum;
import com.seeyon.ctp.common.content.comment.Comment;
import com.seeyon.ctp.common.ctpenumnew.EnumNameEnum;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.common.permission.bo.NodePolicy;
import com.seeyon.ctp.common.permission.bo.Permission;
import com.seeyon.ctp.common.permission.manager.PermissionManager;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.common.po.content.CtpContentAll;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.common.template.manager.TemplateManager;
import com.seeyon.ctp.form.api.FormApi4Cap3;
import com.seeyon.ctp.form.bean.FormAuthViewBean;
import com.seeyon.ctp.form.bean.FormAuthViewFieldBean;
import com.seeyon.ctp.form.bean.FormBean;
import com.seeyon.ctp.form.bean.FormDataMasterBean;
import com.seeyon.ctp.form.bean.FormViewBean;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.DateUtil;
import com.seeyon.ctp.util.Datetimes;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.workflow.exception.BPMException;
import com.seeyon.ctp.workflow.wapi.WorkflowApiManager;
import com.seeyon.v3x.edoc.domain.EdocSummary;

public class BatchGovdocHandler extends BatchAppHandler{

	private static Log LOG = CtpLogFactory.getLog(BatchGovdocHandler.class);
	private OrgManager orgManager;
	private GovdocManager govdocManager;
	private PermissionManager permissionManager;
	private GovdocLockManager govdocLockManager;
	private GovdocSummaryManager govdocSummaryManager;
	private FormApi4Cap3 formApi4Cap3;
	private GovdocFormManager govdocFormManager;
	private CAPFormManager capFormManager;
	private AffairManager affairManager;
	private TemplateManager templateManager;
	private GovdocPubManager govdocPubManager;
	private GovdocExchangeManager govdocExchangeManager;
	private GovdocMarkManager govdocMarkManager;
	private GovdocPishiManager govdocPishiManager;
	private GovdocPishiDao govdocPishiDao;
	private GovdocMarkOpenManager govdocMarkOpenManager;
	
	
	public GovdocMarkOpenManager getGovdocMarkOpenManager() {
		return govdocMarkOpenManager;
	}
	public void setGovdocMarkOpenManager(GovdocMarkOpenManager govdocMarkOpenManager) {
		this.govdocMarkOpenManager = govdocMarkOpenManager;
	}
	public GovdocPishiDao getGovdocPishiDao() {
		return govdocPishiDao;
	}
	public void setGovdocPishiDao(GovdocPishiDao govdocPishiDao) {
		this.govdocPishiDao = govdocPishiDao;
	}
	public GovdocExchangeManager getGovdocExchangeManager() {
		return govdocExchangeManager;
	}
	public void setGovdocExchangeManager(GovdocExchangeManager govdocExchangeManager) {
		this.govdocExchangeManager = govdocExchangeManager;
	}
	public GovdocPubManager getGovdocPubManager() {
		return govdocPubManager;
	}
	public void setGovdocPubManager(GovdocPubManager govdocPubManager) {
		this.govdocPubManager = govdocPubManager;
	}
	public TemplateManager getTemplateManager() {
		return templateManager;
	}
	public void setTemplateManager(TemplateManager templateManager) {
		this.templateManager = templateManager;
	}
	public AffairManager getAffairManager() {
		return affairManager;
	}
	public void setAffairManager(AffairManager affairManager) {
		this.affairManager = affairManager;
	}
	public CAPFormManager getCapFormManager() {
		return capFormManager;
	}
	public void setCapFormManager(CAPFormManager capFormManager) {
		this.capFormManager = capFormManager;
	}
	public GovdocFormManager getGovdocFormManager() {
		return govdocFormManager;
	}
	public void setGovdocFormManager(GovdocFormManager govdocFormManager) {
		this.govdocFormManager = govdocFormManager;
	}
	public PermissionManager getPermissionManager() {
		return permissionManager;
	}
	public void setPermissionManager(PermissionManager permissionManager) {
		this.permissionManager = permissionManager;
	}
	public OrgManager getOrgManager() {
		return orgManager;
	}
	public void setOrgManager(OrgManager orgManager) {
		this.orgManager = orgManager;
	}
	@Override
	public Object getComment(String attitude, String opinionContent, long affairId, long moduleId)
			throws BusinessException {
		Comment opinion = new Comment();
		opinion.setAffairId(affairId);
		opinion.setCtype(Comment.CommentType.comment.getKey());// 批处理的时候设置类型为评论
		opinion.setClevel(1);
		opinion.setPid(0L);
		opinion.setModuleType(4);
		opinion.setModuleId(moduleId);
		opinion.setRelateInfo("[]");
		opinion.setExtAtt1(attitude);
		opinion.setContent(opinionContent);
		return opinion;
	}
	@Override
	public Object getComment(String attitude, String opinionContent, long affairId, long moduleId, String attitudeCode)
			throws BusinessException {
		Comment opinion = new Comment();
		opinion.setAffairId(affairId);
		opinion.setCtype(Comment.CommentType.comment.getKey());// 批处理的时候设置类型为评论
		opinion.setClevel(1);
		opinion.setPid(0L);
		opinion.setModuleType(4);
		opinion.setModuleId(moduleId);
		opinion.setRelateInfo("[]");
		opinion.setExtAtt1(attitude);
		opinion.setExtAtt4(attitudeCode);
		
		opinion.setContent(opinionContent);
		return opinion;
	}
	
	@Override
	@Deprecated
	public Object getComment(Integer attitude, String opinionContent, long affairId, long moduleId)
			throws BusinessException {
		return null;
	}

	@Override
	public ApplicationCategoryEnum getAppEnum() throws BusinessException {
		
		return ApplicationCategoryEnum.edoc;
	}

	@Override
	public FinishResult transFinishWorkItem(long affairId, long summaryId, Object comment, User user,
			Map<String, Object> param) throws BatchException {
		Object formData = param.get("_formData");
		int code = BatchState.Normal.getCode();
		String msg = "";

		FinishResult finishResult = new FinishResult();

		EdocSummary summary = null;
		boolean isLock = false;
		try {
			
			summary = govdocSummaryManager.getSummaryById(summaryId);
			finishResult.setSubject(summary.getSubject());
			if("true".equals((String)param.get("isLast"))){//最后节点不支持批处理
				finishResult.setErrorMsg(ResourceUtil.getString("govdoc.edoc.lastnode"));
				return finishResult;
			}
			//检查流程锁
			String[] checkProcessRet = checkProcess(summary.getProcessId(), user);
			if(!"true".equals(checkProcessRet[0])){
				finishResult.setErrorMsg(checkProcessRet[1]);
			    return finishResult;
			}
			isLock = govdocLockManager.canGetLock(affairId);
			if(!isLock) {
				finishResult.setErrorMsg(ResourceUtil.getString("collaboration.summary.notDuplicateSub"));
				LOG.error(AppContext.currentAccountName() + " 不能获取到map缓存锁，不能执行操作finishWorkItem,affairId" + affairId);
				return finishResult;
			}
			CtpAffair affair = affairManager.get(affairId);
			
			
			if(!affairManager.isAffairValid(affair,true)){
				/*
				 * String errorMsg = ColUtil.getErrorMsgByAffair(affair);
				 * finishResult.setErrorMsg(errorMsg);
				 */
				return finishResult;
			}
			
			
			Comment opinion = (Comment)comment;
			
			// 不同意意见必填
			if(CommentExtAtt1Enum.disagree.getI18nLabel().equals(opinion.getExtAtt1())
			        && Strings.isBlank(opinion.getContent())){
			    
			    NodePolicy nodePolicy = getNodePolicy(affair, summary.getOrgAccountId());
			    Integer disAgredOpinionPlicy = nodePolicy.getDisAgreeOpinionPolicy();
			    boolean _disAgredOpinionPlicy = Integer.valueOf(1).equals(disAgredOpinionPlicy);
			    if(_disAgredOpinionPlicy){ 
			        finishResult.setErrorMsg(ResourceUtil.getString("collaboration.batch.comment.isnull"));
			        return finishResult;
			    }
			}
			
			GovdocDealVO dealVo = new  GovdocDealVO();
			GovdocNewHelper.fillBatchFinishParam(dealVo, summary, affair);
			dealVo.setCurrentDate(DateUtil.currentDate());
			dealVo.setCurrentUser(AppContext.getCurrentUser());
			
			// 流程分支匹配数据
			dealVo.setConditionsOfNodes((String)param.get("conditionsOfNodes"));
			
			dealVo.setFrom("batch");
			//封装节点权限
			govdocPubManager.fillFinishPermisssion(dealVo);//判断是否有签收
			dealVo.setComment(opinion);
			if(summary.getTempleteId() != null) {
				CtpTemplate template = templateManager.getCtpTemplate(summary.getTempleteId());
				dealVo.setTemplate(template);
			}
	    	//判断是否从代录来的
    		if(AppContext.getCurrentUser().getId() != affair.getMemberId()) {
    			String pishiFlag = govdocPishiManager.checkLeaderPishi(AppContext.getCurrentUser().getId(), affair.getMemberId());
    			if("pishi".equals(pishiFlag)) {
    				dealVo.setLeaderPishiFlag("2");
    			}
    		}
			govdocManager.transFinishWorkItem(dealVo);
		}catch(Exception e) {
			
		}finally {
			if(isLock) {
				govdocLockManager.unlockAll(summary, affairId, AppContext.getCurrentUser().getId());
			}
		}
		if(code != BatchState.Normal.getCode()){
			throw new BatchException(code,msg);
		}
		return finishResult;
	}

	@Override
	public Map<String, String> checkAppPolicy(CtpAffair affair, Object summary) throws Exception {
		return checkAppPolicy(affair,summary,"");
	}
	
	@Override
	public Map<String, String> checkAppPolicy(CtpAffair affair, Object summary, String from) throws Exception {
		EdocSummaryBO edocSummary = (EdocSummaryBO)summary;
		if(edocSummary.getGovdocType() == 0) {
			throw new BatchException(322,"");
		}
		NodePolicy policy = getNodePolicy(affair,edocSummary.getOrgAccountId());
		if ("largeFont".equals(from)) {
			policy.setBatch(1);
		}
		
		return checkPolicy(policy);
	}
	@Override
	public Map<String, String> checkPolicy(NodePolicy policy) throws BatchException{
		Map<String, String> returnParam = new HashMap<String, String>();
		returnParam = super.checkPolicy(policy);
		//TODO 校验节点操作
	    String baseAction = policy.getBaseAction();
	    String commonAction = policy.getCommonAction();
	    String advanceAction = policy.getAdvancedAction();
	    //联合发文不能批处理
	    if(commonAction.contains("JointlyIssued")||advanceAction.contains("JointlyIssued")) {
	    	
	    }
	    //分送 分办
	    if(baseAction.contains("Distribute") ||baseAction.contains("FaDistribute")) {
	    	//提示 ：该节点拥有以下策略，无法批处理
	    	throw new BatchException(BatchState.PolicyNotOpe.getCode(),ResourceUtil.getString("govdoc.batch.alert.notdeal.1"));
	    }
		return returnParam;
	}
	/**
	 * 获取意见权限
	 * 
	 * @param affair
	 * @param summary
	 * @return
	 * @throws BatchException 
	 */
    private NodePolicy getNodePolicy(CtpAffair affair, Long orgAccountId) throws BatchException {

        NodePolicy policy = null;
        try {
            //V3xOrgMember sender = orgManager.getMemberById(affair.getSenderId());


            String nodePermissionPolicy = "shenpi";
            // nodePermissionPolicy = activity.getSeeyonPolicy().getId();
            nodePermissionPolicy = affair.getNodePolicy();
            Permission permission = null;
            if(affair.getSubApp() == ApplicationSubCategoryEnum.edoc_fawen.getKey()) {
            	permission = permissionManager.getPermission(EnumNameEnum.edoc_new_send_permission_policy.name(),
                        nodePermissionPolicy, orgAccountId);
            }else if(affair.getSubApp() == ApplicationSubCategoryEnum.edoc_shouwen.getKey()) {
            	permission = permissionManager.getPermission(EnumNameEnum.edoc_new_rec_permission_policy.name(),
                        nodePermissionPolicy, orgAccountId);
            }else if(affair.getSubApp() == ApplicationSubCategoryEnum.edoc_qianbao.getKey()) {
            	permission = permissionManager.getPermission(EnumNameEnum.edoc_new_qianbao_permission_policy.name(),
                        nodePermissionPolicy, orgAccountId);
            }else if(affair.getSubApp() == ApplicationSubCategoryEnum.edoc_jiaohuan.getKey()) {
            	permission = permissionManager.getPermission(EnumNameEnum.edoc_new_change_permission_policy.name(),
                        nodePermissionPolicy, orgAccountId);
            }
            if(permission != null) {
            	policy = permission.getNodePolicy();
            }
            
        } catch (BusinessException e) {
            throw new BatchException(BatchState.Error.ordinal(),
                    ResourceUtil.getString("collaboration.batch.alert.notdeal.20"));
        }

        return policy;
    }
	@Override
	public BatchResult checkApp(CtpAffair affair, Object object) throws BatchException {

	   BatchResult result = new BatchResult();
	   result.setResultCode(BatchState.Normal.ordinal());
	   return result;
	}

	@Override
	public Map<String, String> disagreeStepBack(Map pMap) throws Exception {
		Map<String,String> resonMap = new HashMap<String,String>();
		GovdocDealVO dealVo = new GovdocDealVO();
        dealVo.setCurrentUser(AppContext.getCurrentUser());
        Object from = pMap.get("from");
        if (from != null) {
            dealVo.setFrom(from.toString());
        }
    	String affairId =String.valueOf(pMap.get("affairId"));
    	String summaryId = String.valueOf(pMap.get("summaryId"));
		Comment comment = new Comment();
		String content = (String)pMap.get("collaboration.dealAttitude.disagree");
		comment.setContent(Strings.isBlank(content) ? "" :content);
		comment.setExtAtt1(CommentExtAtt1Enum.disagree.getI18nLabel());
		comment.setExtAtt4(CommentExtAtt1Enum.disagree.name());
		dealVo = GovdocNewHelper.fillBatchStepBackParam(dealVo,Long.valueOf(affairId),Long.valueOf(summaryId),comment);
		boolean isLock = false;
		try {
	        isLock = govdocLockManager.canGetLock(dealVo.getAffairId());
			if (!isLock) {
				resonMap.put("error", AppContext.currentAccountName() + ResourceUtil.getString("govdoc.cache.lock.cannotGet") + dealVo.getAffairId());
				LOG.error(AppContext.currentAccountName() + "不能获取到map缓存锁，不能执行操作stepBack,affairId:" + dealVo.getAffairId());
				return resonMap;
			}
			if(!govdocManager.transStepBack(dealVo)) {
				resonMap.put("error", dealVo.getErrorMsg());
				return resonMap;
			}
		}catch(Exception e) {
        	resonMap.put("error",ResourceUtil.getString("govdoc.exception"));
        	LOG.error("批处理回退出错", e);
		}finally {
			if(isLock) {
				govdocLockManager.unlockAll(dealVo.getSummary(), dealVo.getAffairId(), dealVo.getCurrentUser().getId());
			}
		}
		return resonMap;
	}

	@Override
	public Map<String, String> disagreeStepStop(Map pMap) throws Exception {
		Map<String,String> resonMap = new HashMap<String,String>();
		GovdocDealVO dealVo = new  GovdocDealVO();
        dealVo.setCurrentDate(DateUtil.currentDate());
        dealVo.setCurrentUser(AppContext.getCurrentUser());
        String affairId= (String)pMap.get("affairId");
        String content = (String) pMap.get("collaboration.dealAttitude.termination");
        Comment comment = new Comment();
        comment.setContent(content);
        comment.setExtAtt1(CommentExtAtt1Enum.disagree.getI18nLabel());
        comment.setExtAtt4(CommentExtAtt1Enum.disagree.name());
        boolean isLock = false;
        try {
        	
			GovdocNewHelper.fillBatchStepStopParam(dealVo, Long.valueOf(affairId),comment,"batch");
			 
			isLock = govdocLockManager.canGetLock(dealVo.getAffairId());
			if (!isLock) {
				resonMap.put("error",AppContext.currentAccountName() + ResourceUtil.getString("govdoc.cache.lock.cannotGet.stepStop") + dealVo.getAffairId());
				LOG.error(AppContext.currentAccountName() + "不能获取到map缓存锁，不能执行操作stepStop, affairId:" + dealVo.getAffairId());
				return resonMap;
			}
			 
			if(!govdocPubManager.fillStepStopObj(dealVo)) {
				//WFComponentUtil.webAlertAndClose(response, dealVo.getErrorMsg());
				resonMap.put("error", dealVo.getErrorMsg());
				return resonMap;
			}
			if (dealVo.getAffair().getSubApp() == ApplicationSubCategoryEnum.edoc_jiaohuan.getKey()) {
				govdocExchangeManager.exchangeSign(dealVo.getSummary(), dealVo.getAffair(), dealVo.getCurrentUser().getId());
			}
			if(!govdocManager.transStepStop(dealVo)) {
				resonMap.put("error", dealVo.getErrorMsg());
				return resonMap;
			}
        }catch(Exception e) {
        	resonMap.put("error",ResourceUtil.getString("govdoc.exception"));
        	LOG.error("批处理终止出错", e);
        }finally {
			if (isLock) {
				govdocLockManager.unlockAll(dealVo.getSummary(), dealVo.getAffairId(), dealVo.getCurrentUser().getId());
			}
        }
		return resonMap;
	}

    private String[] checkProcess(String processId,User user) throws BatchException{
		String[] ret = {"true",""};
	    if(Strings.isBlank(processId)){
	        return ret;
	    }
	    WorkflowApiManager wapi = (WorkflowApiManager)AppContext.getBean("wapi");
	    try {
	        String[] re = wapi.checkWorkFlowProcessLock(processId, String.valueOf(user.getId()));
	        
	        return re; 
        }
	    catch (BPMException e) {
            throw new BatchException(BatchState.Error.getCode(), ResourceUtil.getString("collaboration.batch.alert.notdeal.20"));
        }
	}
	@Override
	public Map<String, String> disagreeRepeal(Map pMap) throws Exception {
		Map<String,String> resonMap = new HashMap<String,String>();
    	String affairId =String.valueOf(pMap.get("affairId"));
    	String summaryId = String.valueOf(pMap.get("summaryId"));
        String content = (String)pMap.get("collaboration.dealAttitude.disagree");
        Map resultMap = govdocManager.checkIsCanRepeal(pMap);
        if(resultMap.get("msg")!= null){
        	resonMap.put("error", String.valueOf(resultMap.get("msg")));
        	return resonMap;
        }
		GovdocRepealVO repealVo = GovdocNewHelper.fillBatchRepealVO(summaryId, affairId);
		repealVo.setRepealComment(content);
		repealVo.setExtAtt1(CommentExtAtt1Enum.disagree.getI18nLabel());
		repealVo.setCurrentUser(AppContext.getCurrentUser());
		try {
			String errorMsg = govdocManager.transRepal(repealVo);
			if(Strings.isNotBlank(errorMsg)) {
				resonMap.put("error", errorMsg);
				return resonMap;
			}
		}catch(Exception e) {
			resonMap.put("error",ResourceUtil.getString("govdoc.exception"));
			LOG.error("批处理撤销出错", e);
		}finally {
			govdocLockManager.unlock(Long.valueOf(repealVo.getAffairIdStr()));
		}
		return resonMap;
	}
	@Override
    public BatchCheckResult checkForm(CtpAffair affair, Object object,User user) {

        BatchCheckResult result = new BatchCheckResult();
        result.setAllowed(true);
        EdocSummaryBO summary = (EdocSummaryBO) object;
        EdocSummary edocSummary = null;
        try {
			edocSummary = govdocSummaryManager.getSummaryById(summary.getId());
		} catch (BusinessException e1) {
			
		}
        boolean isCanBatch = true;
        String msg = "";
		Object formData = null;
        // 校验表单必填项
        String bindFormOperation = "";
		CtpContentAll content = GovdocContentHelper.getFormContentByModuleId(affair.getObjectId());
		if (content != null) {
			Long formapp_id = affair.getFormAppId();
			if (formapp_id != null) {
				if (content.getContentTemplateId() != null) {
					formapp_id = content.getContentTemplateId();
				}
				Integer subapp = affair.getSubApp();
				String operation_id = null;
				String formview_id = null;
				if (affair.getApp() == ApplicationCategoryEnum.edoc.getKey()) {
					try {
						Map<String, Object> vomMap = new HashMap<String, Object>();
						vomMap.put("formAppid", formapp_id);
						vomMap.put("govdocType", subapp);
						String rightId = govdocFormManager.getGovdocFormViewRight(vomMap, affair);
						if (Strings.isNotBlank(rightId)) {
							if (rightId.contains("_")) {
								rightId = rightId.split("_")[0];
							}
							String[] para = rightId.split("\\.");
							formview_id = para[0];
							operation_id = para[1];
							bindFormOperation = para[1];
						} else {
							msg = ResourceUtil.getString("govdoc.form.rightId.notFound");
							isCanBatch = false;
						}
						if (Strings.isNotBlank(formview_id) && Strings.isNotBlank(operation_id)) {
							FormBean formBean = formApi4Cap3.getForm(formapp_id);
							FormViewBean formViewBean = formBean.getFormView(Long.valueOf(formview_id));
							FormDataMasterBean masterData = formApi4Cap3.getDataMasterBeanById(summary.getFormRecordid(), formBean, null);
							if(formViewBean!=null) {
								List<FormAuthViewBean> fav = formViewBean.getAllOperations();
								for (FormAuthViewBean formAuthViewBean : fav) {
									String _operation_id = formAuthViewBean.getId().toString();
									
									if (operation_id.equals(_operation_id)) { 
										List<FormAuthViewFieldBean> favf = formAuthViewBean.getFormAuthorizationFieldList();
										for (FormAuthViewFieldBean formAuthViewFieldBean : favf) {
											if(formAuthViewFieldBean.isNotNullable()) {
												//必填时，判断是否有值
												Object obj = masterData.getFieldValue(formAuthViewFieldBean.getFormFieldBean().getName());
												if(obj == null) {
													msg = ResourceUtil.getString("govdoc.form.field.text");
													isCanBatch = false;
													break;
												}
											}
										}
									}
									if(!isCanBatch) {
										break;
									}
									
								}
							}
						}
					}catch(Exception e) {
						
					}
				}
			}
		}
		if(!isCanBatch) {
			result.setAllowed(false);
			result.setMsg(msg);
			return result;
		}
        // 校验表单校验规则
        Map<String, Object> ret = capFormManager.checkRule(summary.getId(), summary.getFormAppid(), summary.getFormRecordid(), bindFormOperation);
		formData = ret.get("formData");
		result.setFormData(formData);
		String isPass = (String)ret.get("isPass");
        if ("false".equals(isPass)) {
			/*
			 * LOG.info("[checkRule]批处理：判断表单是否能批处理: FALSE,传入参数：formMasterDataId：" +
			 * summary.getFormRecordid() + ", formAppID:" + summary.getFormAppid() +
			 * ",formRightId:" + bindFormOperation + ",summaryId:" + summary.getId());
			 */
            result.setAllowed(false);
            result.setMsg(ResourceUtil.getString("collaboration.batch.alert.notdeal.31"));
            return result;
        }
        else {
			/*
			 * LOG.info("[checkRule]批处理：判断表单是否能批处理: True,传入参数：formMasterDataId：" +
			 * summary.getFormRecordid() + ", formAppID:" + summary.getFormAppid() +
			 * ",formRightId:" + bindFormOperation + ",summaryId:" + summary.getId());
			 */
        }
        //表单锁校验
        try {
        	GovdocLockObject lockObj = govdocLockManager.formAddLock(affair.getId(),false);
        	if(lockObj != null && "0".equals(lockObj.getCanSubmit())) {
        		result.setAllowed(false);
        		result.setMsg(ResourceUtil.getString("collaboration.common.flag.editingForm",lockObj.getLoginName(),lockObj.getFrom()));//表单锁
        		return result;
        	}
        }catch(Exception e) {
        	LOG.error("公文批处理添加表单锁异常", e);
        }
        //文号校验
        try {
        	boolean isUsed = false;
        	boolean showMarkCall = false;
        	String markType = "0";
        	if(summary.getGovdocType() == 1&&Strings.isNotBlank(edocSummary.getDocMark())) {//发文
        		showMarkCall = govdocMarkOpenManager.isMarkShowCall("0");
        		isUsed = govdocMarkManager.checkMarkIsUsed(summary.getId().toString(), summary.getOrgAccountId().toString(), summary.getGovdocType().toString(), String.valueOf(summary.getEdocType()), "", "0", edocSummary.getDocMark());
        	}else if(summary.getGovdocType() == 2&&Strings.isNotBlank(edocSummary.getSerialNo())) {//收文
        		markType = "1";
        		showMarkCall = govdocMarkOpenManager.isMarkShowCall("1");
        		isUsed = govdocMarkManager.checkMarkIsUsed(summary.getId().toString(), summary.getOrgAccountId().toString(), summary.getGovdocType().toString(), String.valueOf(summary.getEdocType()), "", "1", edocSummary.getSerialNo());
        	}else if(summary.getGovdocType() == 4&&Strings.isNotBlank(edocSummary.getDocMark())) {//交换
        		markType = "2";
        		showMarkCall = govdocMarkOpenManager.isMarkShowCall("2");
        		isUsed = govdocMarkManager.checkMarkIsUsed(summary.getId().toString(), summary.getOrgAccountId().toString(), summary.getGovdocType().toString(), String.valueOf(summary.getEdocType()), "", "2", edocSummary.getDocMark());
        	}
			if(!isUsed&&showMarkCall) {
				isUsed = govdocMarkManager.checkMarkIsCalled(summary.getId().toString(), summary.getOrgAccountId().toString(), summary.getGovdocType().toString(), String.valueOf(summary.getEdocType()), "", markType, edocSummary.getDocMark());
			}
			if(isUsed) {
        		result.setAllowed(false);
        		result.setMsg(ResourceUtil.getString("edoc.docmark.exist"));//文号重复
        		return result;
			}
		} catch (BusinessException e) {
			LOG.error("公文批处理校验文号异常", e);
		}
        return result;
    }
	public GovdocManager getGovdocManager() {
		return govdocManager;
	}
	public void setGovdocManager(GovdocManager govdocManager) {
		this.govdocManager = govdocManager;
	}
	public GovdocLockManager getGovdocLockManager() {
		return govdocLockManager;
	}
	public void setGovdocLockManager(GovdocLockManager govdocLockManager) {
		this.govdocLockManager = govdocLockManager;
	}
	public GovdocSummaryManager getGovdocSummaryManager() {
		return govdocSummaryManager;
	}
	public void setGovdocSummaryManager(GovdocSummaryManager govdocSummaryManager) {
		this.govdocSummaryManager = govdocSummaryManager;
	}
	public FormApi4Cap3 getFormApi4Cap3() {
		return formApi4Cap3;
	}
	public void setFormApi4Cap3(FormApi4Cap3 formApi4Cap3) {
		this.formApi4Cap3 = formApi4Cap3;
	}
	public GovdocMarkManager getGovdocMarkManager() {
		return govdocMarkManager;
	}
	public void setGovdocMarkManager(GovdocMarkManager govdocMarkManager) {
		this.govdocMarkManager = govdocMarkManager;
	}
	public GovdocPishiManager getGovdocPishiManager() {
		return govdocPishiManager;
	}
	public void setGovdocPishiManager(GovdocPishiManager govdocPishiManager) {
		this.govdocPishiManager = govdocPishiManager;
	}
}
