package com.seeyon.apps.govdoc.manager.impl;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.lang3.math.NumberUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.apps.collaboration.api.CollaborationApi;
import com.seeyon.apps.govdoc.bo.GovdocLockObject;
import com.seeyon.apps.govdoc.dao.GovdocExchangeDao;
import com.seeyon.apps.govdoc.helper.GovdocAffairHelper;
import com.seeyon.apps.govdoc.helper.GovdocContentHelper;
import com.seeyon.apps.govdoc.helper.GovdocHelper;
import com.seeyon.apps.govdoc.helper.GovdocOrgHelper;
import com.seeyon.apps.govdoc.manager.GovdocCommentManager;
import com.seeyon.apps.govdoc.manager.GovdocContentManager;
import com.seeyon.apps.govdoc.manager.GovdocDocManager;
import com.seeyon.apps.govdoc.manager.GovdocDocTemplateManager;
import com.seeyon.apps.govdoc.manager.GovdocExchangeAccountManager;
import com.seeyon.apps.govdoc.manager.GovdocExchangeManager;
import com.seeyon.apps.govdoc.manager.GovdocFormManager;
import com.seeyon.apps.govdoc.manager.GovdocLockManager;
import com.seeyon.apps.govdoc.manager.GovdocManager;
import com.seeyon.apps.govdoc.manager.GovdocPishiManager;
import com.seeyon.apps.govdoc.manager.GovdocSummaryManager;
import com.seeyon.apps.govdoc.po.GovdocExchangeDetail;
import com.seeyon.apps.govdoc.po.GovdocExchangeMain;
import com.seeyon.apps.govdoc.vo.GovdocRepealVO;
import com.seeyon.apps.govdoc.vo.GovdocWorkflowVO;
import com.seeyon.apps.wpstrans.listener.WpsTransEvent;
import com.seeyon.apps.wpstrans.manager.WpsTransManager;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.ModuleType;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.affair.util.WFComponentUtil;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.config.manager.ConfigManager;
import com.seeyon.ctp.common.constants.ApplicationCategoryEnum;
import com.seeyon.ctp.common.constants.ApplicationSubCategoryEnum;
import com.seeyon.ctp.common.content.affair.constants.StateEnum;
import com.seeyon.ctp.common.content.comment.Comment;
import com.seeyon.ctp.common.content.comment.CommentManager;
import com.seeyon.ctp.common.content.mainbody.MainbodyManager;
import com.seeyon.ctp.common.content.mainbody.MainbodyType;
import com.seeyon.ctp.common.ctpenumnew.EnumNameEnum;
import com.seeyon.ctp.common.dao.paginate.Pagination;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.filemanager.dao.V3XFileDAO;
import com.seeyon.ctp.common.filemanager.manager.FileManager;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.office.manager.OfficeBakFileManager;
import com.seeyon.ctp.common.office.trans.util.OfficeTransHelper;
import com.seeyon.ctp.common.permission.bo.Permission;
import com.seeyon.ctp.common.permission.enums.PermissionAction;
import com.seeyon.ctp.common.permission.manager.PermissionManager;
import com.seeyon.ctp.common.permission.vo.PermissionVO;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.common.po.config.ConfigItem;
import com.seeyon.ctp.common.po.content.CtpContentAll;
import com.seeyon.ctp.common.po.filemanager.V3XFile;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.form.manager.GovdocTemplateDepAuthManager;
import com.seeyon.ctp.form.po.FormPermissionConfig;
import com.seeyon.ctp.form.util.EntityPo;
import com.seeyon.ctp.form.util.FormEntityName;
import com.seeyon.ctp.form.util.permission.factory.PermissionFatory;
import com.seeyon.ctp.resourceEngine.manager.PrivilegeConfigManager;
import com.seeyon.ctp.util.DateUtil;
import com.seeyon.ctp.util.FileUtil;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.XMLCoder;
import com.seeyon.ctp.util.annotation.AjaxAccess;
import com.seeyon.ctp.util.json.JSONUtil;
import com.seeyon.ctp.workflow.exception.BPMException;
import com.seeyon.ctp.workflow.manager.CaseManager;
import com.seeyon.ctp.workflow.util.WorkflowUtil;
import com.seeyon.ctp.workflow.wapi.WorkflowApiManager;
import com.seeyon.v3x.edoc.domain.EdocDocTemplate;
import com.seeyon.v3x.edoc.domain.EdocSummary;
import com.seeyon.v3x.exchange.domain.ExchangeAccount;
import com.seeyon.v3x.system.signet.domain.V3xHtmDocumentSignature;
import com.seeyon.v3x.system.signet.enums.V3xHtmSignatureEnum;
import com.seeyon.v3x.system.signet.manager.V3xHtmDocumentSignatManager;

import net.joinwork.bpm.definition.BPMActivity;
import net.joinwork.bpm.definition.BPMHumenActivity;
import net.joinwork.bpm.definition.BPMProcess;
import net.joinwork.bpm.engine.execute.BPMCase;
import net.joinwork.bpm.engine.wapi.WorkItemManager;

public class GovdocAjaxManagerImpl extends GovdocManagerImpl {

	private Log LOGGER = LogFactory.getLog(GovdocAjaxManagerImpl.class);
	
	private GovdocManager govdocManager;
	private GovdocSummaryManager govdocSummaryManager;
	private GovdocDocTemplateManager govdocDocTemplateManager;
	private GovdocDocManager govdocDocManager;
	private GovdocFormManager govdocFormManager;
	private GovdocCommentManager govdocCommentManager;
	private GovdocPishiManager govdocPishiManager;
	private GovdocLockManager govdocLockManager;
	private WpsTransManager wpsTransManager;
	private AffairManager affairManager;
	private MainbodyManager ctpMainbodyManager;
	private PermissionManager permissionManager;
	private ConfigManager configManager;
	private CollaborationApi collaborationApi;
	private GovdocContentManager govdocContentManager;
	private V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager;
	private GovdocTemplateDepAuthManager govdocTemplateDepAuthManager;
	private GovdocExchangeDao govdocExchangeDao;
	private GovdocExchangeManager govdocExchangeManager;
	private GovdocExchangeAccountManager govdocExchangeAccountManager;
	private PrivilegeConfigManager privilegeConfigManager;
	private OfficeBakFileManager officeBakFileManager;
	private FileManager fileManager;
	private WorkflowApiManager wapi;
	private WorkItemManager workItemManager;
	private CaseManager caseManager;
	/********************************* Affair对象相关 start **********************************/
	@AjaxAccess
    public String checkAffairValid(String affairId) throws NumberFormatException, BusinessException {
		return GovdocAffairHelper.checkAffairValid(affairId, true,"");
	}
	@AjaxAccess
	public String getSenderAffairBySummaryId(Long summaryId) throws BusinessException {
		CtpAffair ctpAffair = affairManager.getSenderAffair(summaryId);
		if(Strings.isBlank(ctpAffair.getProcessId())) {
			Map<String, Object> map = govdocSummaryManager.getSummaryMapById(summaryId);
			if(map.get("processId") != null) {
				ctpAffair.setProcessId((String)map.get("processId"));
			}
		}
		return JSONUtil.toJSONString(ctpAffair);
	}
	
	@AjaxAccess
	public String getSenderAffairsBySummaryIds(String summaryIds) throws BusinessException{
		if(Strings.isBlank(summaryIds)){
			return "";
		}
		String[] tempIds = summaryIds.split(",");
		Long summaryId = null;
		CtpAffair ctpAffair = null;
		Map<String, CtpAffair> affairMap = new HashMap<String, CtpAffair>();
		List<Long> summaryIdList = new ArrayList<Long>();
		for (int i = 0; i < tempIds.length; i++) {
			summaryId = Long.valueOf(tempIds[i]);
			ctpAffair = affairManager.getSenderAffair(summaryId);
			if(Strings.isBlank(ctpAffair.getProcessId())) {
				summaryIdList.add(summaryId);
			}
			affairMap.put(tempIds[i], ctpAffair);
		}
		
		if(Strings.isNotEmpty(summaryIdList)) {
			List<Map<String, Object>> summaryList = govdocSummaryManager.getSummaryListById(summaryIdList);
			for(Map<String, Object> map : summaryList) {
				String id = map.get("id").toString();
				String processId = (String)map.get("processId");
				if(affairMap.get(id) != null) {
					affairMap.get(id).setProcessId(processId);
				}
			}
		}
		
		return JSONUtil.toJSONString(affairMap);
	}
	
	/**
    * 获取当前事项的所有memberId
    * @param String
    * @return
    */
	@AjaxAccess
    public List<Long> getColAllMemberId(String summaryId){
        return GovdocAffairHelper.getColAllMemberId(summaryId);        
    }
	/**
	 * 查找最后一条已办affair
	 * @param summaryId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public CtpAffair getLastDoneAffair(Long summaryId, Long currentUserId) throws BusinessException {
		Map<String,Object> conditions = new HashMap<String,Object>();
		conditions.put("memberId", currentUserId);
		conditions.put("objectId", summaryId);
		conditions.put("state", StateEnum.col_done.getKey());
		conditions.put("app", 4);
		List<CtpAffair> list = affairManager.getByConditions(new FlipInfo(), conditions );
		CtpAffair affair = list.get(0);
		for (int i=1;i<list.size();i++) {
			if(affair.getCompleteTime() == null){
				affair = list.get(i);
				continue;
			}
			if(list.get(i).getCompleteTime() == null){
				continue;
			}
			if(affair.getCompleteTime().getTime() < list.get(i).getCompleteTime().getTime()){
				affair = list.get(i);
			}
		}
		return affair;
	}
	/**
	 * 查找affair
	 * @param affairId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public CtpAffair getAffairById(Long affairId) throws BusinessException {
		return affairManager.get(affairId);
	}

	/********************************* Affair对象相关    end **********************************/
	
	
	/********************************* 交换相关 start **********************************/
	/**
	 *  AJAX方法：校验是否允许回退分办
	 */
	@AjaxAccess
	public boolean isFromDistributed(Long summaryId) throws BusinessException {
		return govdocExchangeManager.findDetailByRecSummaryId(summaryId) != null;
	}
	/**
     * AJAX方法：取回前验证是否已分送出去
     * @throws BusinessException
     */
	@AjaxAccess
	public boolean hasDistributed(Long summaryId) throws BusinessException {
		GovdocExchangeMain main = govdocExchangeManager.findBySummaryId(summaryId, null);
		EdocSummary summary = govdocSummaryManager.getSummaryById(summaryId);
		if(main != null)
		{
			//这种情况需要区分当前affair是分送前还是分送后的
			//1.首先拿到当前所有的affair
			List<CtpAffair> affairs = affairManager.getAffairs(summaryId);
			CtpAffair currentAffair = null;
			CtpAffair fenBanAffair = null;
			long userId = AppContext.currentUserId();
			for (CtpAffair ctpAffair : affairs) {
				if(ctpAffair.isDelete()){
					continue;
				}
				if(ctpAffair.getState() == 4 && ("faxing".equals(ctpAffair.getNodePolicy())|| isFensong(ctpAffair,summary))){
					fenBanAffair = ctpAffair;
				}
				if(ctpAffair.getState() == 4 && ctpAffair.getMemberId() == userId){
					if(currentAffair == null){
						currentAffair = ctpAffair;
					}else{
						if(currentAffair.getReceiveTime().getTime() < ctpAffair.getReceiveTime().getTime()){
							currentAffair = ctpAffair;
						}
					}
				}
			}
			if(fenBanAffair == null)
			{
				return  false;
			}
			if(currentAffair.getId().longValue() == fenBanAffair.getId().longValue() )
			{
				return  true;
			}
			if("faxing".equals(currentAffair.getNodePolicy()) || isFensong(currentAffair,summary))
			{
				return true;
			}
			return currentAffair.getReceiveTime().getTime() < fenBanAffair.getReceiveTime().getTime();

		}
		else
		{
			return false;
		}
	}
	@AjaxAccess
	public String getExchangeContentId(Long summaryId) throws BusinessException {
		GovdocExchangeDetail detail = govdocExchangeManager.findDetailByRecSummaryId(summaryId);
		GovdocExchangeMain main = govdocExchangeManager.getGovdocExchangeMainById(detail.getMainId());
		if(main != null){
			return main.getOriginalFileId() !=null ? String.valueOf(main.getOriginalFileId()) : "" ;
		}
		return "";
	}
	@AjaxAccess
	public String[] validateJointlyHasNextPersion(Long summaryId, String units) throws BusinessException {
		return govdocExchangeManager.validateJointlyHasNextPersion(summaryId, units);
	}
	@AjaxAccess
	public String[] validateJointlyIssyedUnit(Long summaryId,String units) throws BusinessException {
		return govdocExchangeManager.validateJointlyIssyedUnit(summaryId, units);
	}
	@AjaxAccess
	public String validateExistAccountOrDepartment(String orgIdNames) throws BusinessException{
		return govdocExchangeManager.validateExistAccountOrDepartment(orgIdNames);
	}
	@AjaxAccess
	public String validateExistAccount(String orgString) throws BusinessException{
		return govdocExchangeManager.validateExistAccount(orgString);
	}
	@AjaxAccess
	public String isConnectWhenSend(String ids) throws BusinessException {
		return govdocExchangeManager.isConnectWhenSend(ids);
	}
	/**
	 * 查询交换单位的名称
	 * @param idArrays
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String getExchangeUnit(String idArrays) throws BusinessException {
		String[] idStrings = idArrays.split(",");
		String names = "";
		EntityPo entityPo = null;
		for(String id:idStrings){
			if(!"、".equals(id)){
				entityPo = FormEntityName.getNames(id);
				if(entityPo != null){
					names +=entityPo.getAccountName()+",";
				}
			}
		}
		return "{\"names\":\""+names+"\"}";
	}
	@AjaxAccess
	public GovdocExchangeDetail getExchangeDetailById(Long detailId) {
		return govdocExchangeManager.getExchangeDetailById(detailId);
	}
	@AjaxAccess
	public String reSend(Map<String, String> params) throws BusinessException {
		return govdocExchangeManager.reSend(params);
	}
	@AjaxAccess
	public String press(Map<String, String> params) throws BusinessException {
		return govdocExchangeManager.press(params);
	}
	@AjaxAccess
	public String govdocExchangeDetailCount(Long mainId) throws BusinessException {
		return govdocExchangeManager.govdocExchangeDetailCount(mainId);
	}
	@AjaxAccess
	public ExchangeAccount getExchangeAccount(Long id) throws BusinessException {
		return govdocExchangeAccountManager.getExchangeAccount(id);
	}
	@AjaxAccess
	public boolean checkIsCoOrganizer(Long summaryId) throws BusinessException {
		return govdocExchangeManager.checkIsCoOrganizer(summaryId);
	}
	@AjaxAccess
	public boolean checkCoOrganizerProcessIsFinish(Long summaryId) throws BusinessException{
		return govdocExchangeManager.checkCoOrganizerProcessIsFinish(summaryId);
	}
	/********************************* 交换相关    end **********************************/
	
	
	/********************************* 正文相关 start **********************************/
	/**
	 * 判断是否是ofd类型转公告
	 * @param summaryId
	 * @return
	 * @throws NumberFormatException
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String isOfdBulIssue(String summaryId) throws NumberFormatException, BusinessException {
		CtpContentAll bodyContent = GovdocContentHelper.getFirstBodyContentByModuleId(Long.parseLong(summaryId));	
		// 580增加判断，如果是ofd，暂时不支持转公告
		if (bodyContent != null && bodyContent.getContentType() != null && bodyContent.getContentType() == 46) {
			return "true";
		}
		return "false";
	}
	@AjaxAccess
	public String transConvertWordToPdf(Map<String, Object> params) {
		String result = "success";
		//Long processId = Long.valueOf((String) params.get("processId"));
		Long summaryId = Long.valueOf((String) params.get("summaryId"));
		//Long affairId = Long.valueOf((String) params.get("affairId"));
		String pdfId = (String) params.get("pdfId");
		try {
			List<CtpContentAll> contents = GovdocContentHelper.getContentListByModuleId(summaryId);
			CtpContentAll pdfContent = null;
			for (CtpContentAll content : contents) {
				if(content.getContentType().intValue() != 20) {
					if(content.getContentType().intValue() == MainbodyType.Pdf.getKey()) {
						pdfContent = content;
						break;
					}
				}
			}
			if(pdfContent == null) {
				pdfContent = new CtpContentAll();
				pdfContent.setIdIfNew();
				pdfContent.setCreateDate(new Date());
				pdfContent.setCreateId(AppContext.currentUserId());
				pdfContent.setModuleTemplateId(0L);
				pdfContent.setContentTemplateId(0L);
			}
//			pdfContent.setTransId(AppContext.currentUserId());
			pdfContent.setModifyDate(new Date());
			pdfContent.setModifyId(AppContext.currentUserId());
			pdfContent.setModuleType(ApplicationCategoryEnum.edoc.key());
			pdfContent.setModuleId(summaryId);			
			pdfContent.setContentType(MainbodyType.Pdf.getKey());
			pdfContent.setContent(pdfId+"");
			pdfContent.setSort(3);
//			pdfContent.setTransId(summaryId);
			ctpMainbodyManager.saveOrUpdateContentAll(pdfContent);
			
			/*processLogManager.insertLog(AppContext.getCurrentUser(),Long.valueOf(processId),
      	    		affairId, ProcessLogAction.processEdoc, String.valueOf(ProcessEdocAction.wordTransPDF.getKey()));*/
		} catch (Exception e) {
			result = ResourceUtil.getString("govdoc.trans2PdfError");
			LOGGER.error(result, e);
			//e.printStackTrace();
		}
		Map<String,Object> map=new HashMap<String, Object>(1);
		map.put("rs",result);
		return JSONUtil.toJSONString(map);
	}
	/**
     * 前端请求保存正文
     * @param map
     * @return
     * @throws BusinessException
     */
	@AjaxAccess
    public boolean saveDealGovdocBody(Map<String,String> map) {
    	try {
			CtpContentAll newContentAll = new CtpContentAll();
			MainbodyType bodyType = MainbodyType.getEnumByKey(Integer.valueOf(map.get("contentType")));
			CtpContentAll contentAlls = GovdocContentHelper.getBodyContentByModuleIdAndType(Long.valueOf(map.get("summaryId")), bodyType);
			if (null != contentAlls) {
				newContentAll = contentAlls;
			}
			if(newContentAll.getId()==null){
				newContentAll.setIdIfNew();
			}
			newContentAll.setModuleId(Long.valueOf(map.get("summaryId")));
			newContentAll.setCreateId(AppContext.getCurrentUser().getId());
			newContentAll.setCreateDate(new Date());
			newContentAll.setContent(map.get("content"));
			newContentAll.setContentType(Integer.valueOf(map.get("contentType")));
			newContentAll.setModuleType(ApplicationCategoryEnum.edoc.getKey()); //公文类型
			newContentAll.setModifyDate(new Date());
			ctpMainbodyManager.saveOrUpdateContentAll(newContentAll);
		} catch (Exception e) {
			LOGGER.error(e);
			//e.printStackTrace();
			return false;
		}
		return true;
    }
	/**
	 * 前端请求修改正文的修改时间
	 * @param map
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
    public boolean updateContentUpdateDate(Map<String,String> map) throws BusinessException{
    	try {
			CtpContentAll newContentAll = new CtpContentAll();
			CtpContentAll contentAlls = GovdocContentHelper.getBodyContentByModuleId(Long.valueOf(map.get("summaryId")),false);
			if (null != contentAlls) {
				newContentAll = contentAlls;
				newContentAll.setModifyDate(new Date());
				ctpMainbodyManager.saveOrUpdateContentAll(newContentAll);
			}
		} catch (Exception e) {
			LOGGER.error(e);
			return false;
		}
		return true;
    }
	/**
	 * 判断是否存在ofd正文
	 * @param fileId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String validateOfdContent(String fileId) throws BusinessException  {
		V3XFile v3xFile = fileManager.getV3XFile(Long.valueOf(fileId));
		String f="no";
		if (v3xFile!=null && ("application/ofd".equals(v3xFile.getMimeType())||"application/pdf".equals(v3xFile.getMimeType()))) {
			f="success";
		}
		Map<String,Object> map=new HashMap<String, Object>(1);
		map.put("rs",f);
		return JSONUtil.toJSONString(map);
	}
	
	/**
	 * 判断是否存在wps正文，如果不存在，则复制一个模板的正文
	 * @param fileId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String checkWpsBodyExists(String fileId,String templateBodyId) throws BusinessException  {
		V3XFile v3xFile = fileManager.getV3XFile(Long.valueOf(fileId));
		if (v3xFile == null) {
			V3XFile tempV3xFile = fileManager.getV3XFile(Long.valueOf(templateBodyId));
			if(tempV3xFile != null){
				File tempFile = fileManager.getFile(tempV3xFile.getId());
				File file = new File(fileManager.getFolder(new Date(), true) + File.separator + fileId);
				FileUtil.copyFile(tempFile, file);
			}
		}
		return "success";
	}

	/**
	 * 克隆正文
	 * @param fileId 原始正文
	 * @param newFileId 新正文id
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String cloneContent(String fileId,String newFileId) throws BusinessException  {
		V3XFileDAO v3xFileDAO = (V3XFileDAO) AppContext.getBean("v3xFileDAO");
		V3XFile xsnFile = v3xFileDAO.get(Long.valueOf(fileId));
		String f="no";
		if (xsnFile != null) {
			try {
				//bean对象克隆
				V3XFile newFile = (V3XFile) BeanUtils.cloneBean(xsnFile);
				newFile.setId(Long.valueOf(newFileId));
				newFile.setFilename(fileId+"");
				newFile.setCreateDate(DateUtil.currentDate());
				newFile.setUpdateDate(DateUtil.currentDate());
				newFile.setCreateMember(AppContext.currentUserId());
				fileManager.save(newFile);
				//文件复制
				File dfile = fileManager.getFile(xsnFile.getId());
				File dirFile = new File(fileManager.getFolder(newFile.getCreateDate(), true) + File.separator + newFileId);
				FileUtil.copyFile(dfile, dirFile);
				f="success";
			} catch (Exception e) {
			}
		}
		Map<String,Object> map=new HashMap<String, Object>(1);
		map.put("rs",f);
		return JSONUtil.toJSONString(map);
	}
	/**
	 * 判断是否存在wps正文
	 * @param fileId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String validateWpsContent(String fileId,String bodyType) throws BusinessException  {
		V3XFile v3xFile = fileManager.getV3XFile(Long.valueOf(fileId));
		if("Wpsword".equals(bodyType)){
			if (v3xFile!=null && "application/vnd.openxmlformats-officedocument.wordprocessingml.document".equals(v3xFile.getMimeType())) {
				return "success";
			}
		}
		/*if("".equals(bodyType)){
			if (v3xFile!=null && "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet".equals(v3xFile.getMimeType())) {
				return "success";
			}
		}*/
		return "no";
	}
	@AjaxAccess
	public String transToOfd(Map<String, Object> params) {
		try {
			WpsTransEvent event = new WpsTransEvent(this);
			String summaryId = (String) params.get("summaryId");
			String affairId = (String) params.get("affairId");
			event.setAffair(affairManager.get(Long.valueOf(affairId)));
			event.setSummary(govdocSummaryManager.getSummaryById(Long.valueOf(summaryId)));
			if(wpsTransManager != null && !wpsTransManager.transToOfd(event)){
				return ResourceUtil.getString("govdoc.conversion.exceptionOFD");
			}
		} catch (Exception e) {
			LOGGER.error("转换ofd正文异常",e);
			return ResourceUtil.getString("govdoc.conversion.exceptionOFD");
		}
		return "success";
	}
	@SuppressWarnings("unchecked")
	@AjaxAccess
    public boolean isShowContentByAffairId(long affairId,long summaryId) throws BusinessException{
    	CtpAffair affair = affairManager.get(affairId);
    	EdocSummary edocSummary = govdocSummaryManager.getSummaryById(Long.valueOf(summaryId));
    	long formId = edocSummary.getFormAppid();
		String category = PermissionFatory.getPermBySubApp(edocSummary.getGovdocType()).getCategorty();
		String configItem = collaborationApi.getPolicyByAffair(affair).getId();
		Permission permission = permissionManager.getPermission(category, configItem, AppContext.getCurrentUser().getAccountId());
		long permissionId = permission.getFlowPermId();
		FormPermissionConfig formPermissionConfig = govdocFormManager.getConfigByFormId(formId);
		if(null != formPermissionConfig){
			Map<String,String> conentShowMap = (Map<String, String>) JSONUtil.parseJSONString(formPermissionConfig.getShowContentConfig());
    		if(null != conentShowMap){
    			for(String key:conentShowMap.keySet()){
	    			if(permissionId == Long.valueOf(key)){
	    				if("false".equals(conentShowMap.get(key))){
	    					return false;
	    				}
	    			}
	    		}
    		}
		}
		return true;
    }
	
	@AjaxAccess
	public void deleteContentHistoryBeforeSubmit(Long summaryId) throws BusinessException {
		List<CtpContentAll> contentList = ctpMainbodyManager.getContentListByModuleIdAndModuleType(ModuleType.edoc, summaryId);
		if(contentList!=null&&contentList.size()>0){
			//List<CtpContentAll> formContentList = new ArrayList<CtpContentAll>();
			for(CtpContentAll c:contentList){
				if(MainbodyType.FORM.getKey()==c.getContentType()){
					ctpMainbodyManager.onlyDeleteContentById(c.getId());
				}
			}
		}
	}
	/**
	 * 获取最终summary正文类型
	 * @param summaryId
	 * @return
	 */
	@AjaxAccess
	//获取最终summary正文类型
	public Map getFirstContentType(Long summaryId) {
		Map<String,String> result = new HashMap<String, String>();
		result.put("bodyType","");
		if(null != summaryId){
			CtpContentAll govdocContentAll = GovdocContentHelper.getTransBodyContentByModuleId(summaryId);
			if(null != govdocContentAll){
				result.put("bodyType",MainbodyType.getEnumByKey(govdocContentAll.getContentType()).name());
				result.put("pdfId",govdocContentAll.getContent());
				return result;
			}
		}
		return result;
	}
	@AjaxAccess
	public void bindPdfContent(String key, String value1, String value2) throws BusinessException {
		value1 = value1.trim();
		if ("serialNo".equals(key)) {
			configManager.deleteConfigItem("pdfContentSet", "serialNo");
			configManager.addConfigItem("pdfContentSet", "serialNo", value1, 1L);
		}else if ("users".equals(key)) {
			ConfigItem item = configManager.getConfigItem("pdfContentSet", "authUsers");
			if (item == null) {
				configManager.addConfigItem("pdfContentSet", "authUsers", "", 1L);
				item = configManager.getConfigItem("pdfContentSet", "authUsers");
			}
			item.setExtConfigValue(value1);
			item.setConfigValue(value2);
			configManager.updateConfigItem(item);
		}
	}
	@AjaxAccess
	public List<V3xHtmDocumentSignature> getSignaturebySummaryId(Long summaryId) {
		Pagination.setMaxResults(50);
		List<V3xHtmDocumentSignature> signatuers = v3xHtmDocumentSignatManager.findBySummaryIdAndType(summaryId, V3xHtmSignatureEnum.HTML_SIGNATURE_DOCUMENT.getKey());
		return signatuers;
	}
	@AjaxAccess
	public String createOFDBodies(String summaryId, String ofdFileId) {
		try {
			return govdocContentManager.createOFDBodies(summaryId,ofdFileId);
		} catch(Exception e) {
			return "false";
		}
	}
	@AjaxAccess
	public void createV3XFile4UploadContent(String fileId,String bodyType,String size) {
		V3XFile file = new V3XFile();
		file.setId(Long.valueOf(fileId));
		file.setFilename(fileId);
		file.setCreateDate(new Date());
		file.setCreateMember(AppContext.currentUserId());
		file.setAccountId(AppContext.currentAccountId());
		file.setUpdateDate(file.getCreateDate());
		file.setCategory(1);
		
		file.setSize(Long.valueOf(size));
        if (bodyType != null) {
            if (bodyType.toLowerCase().contains("wps")) {
            	file.setMimeType("application/wps");
            } else if (bodyType.toLowerCase().contains("ofd")) {
            	file.setMimeType("application/ofd");
            }else if (bodyType.toLowerCase().contains("docx") || bodyType.toLowerCase().contains("officeword")) {
            	file.setMimeType("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
            }else if (bodyType.toLowerCase().contains("xlsx") || bodyType.toLowerCase().contains("excel")) {
            	file.setMimeType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
            }else if (bodyType.toLowerCase().contains("pdf")) {
            	file.setMimeType("application/pdf");
            }
        }
		
		fileManager.save(file);
	}
	/********************************* 正文相关   end **********************************/
	
	
	
	/********************************* 操作相关 start **********************************/
	@SuppressWarnings("rawtypes")
	@AjaxAccess
	public Map checkIsCanRepeal(Map params) throws BusinessException {
		return govdocManager.checkIsCanRepeal(params);
	}
	/**
	 * AJAX方法：流程撤销
	 * @param repealVO
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String transRepal(GovdocRepealVO repealVO) throws BusinessException {
		return govdocManager.transRepal(repealVO);
	}
	/**
	 * AJAX方法：删除前验证流程是否允许删除
	 * @param param
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String checkCanDelete(Map<String, String> param) throws BusinessException {
		String affairIds = param.get("affairIds");
		String result = "";
		String from = param.get("fromMethod");
		List<CtpAffair> affairList = null;
		if (Strings.isNotBlank(affairIds)) {
			affairList = new ArrayList<CtpAffair>();
			String[] affairs = affairIds.split("[*]");
			for (String affairId : affairs) {
				Long _affairId = new Long(affairId);
				CtpAffair affair = affairManager.get(_affairId);
				affairList.add(affair);
				int state = affair.getState();
				if (state != StateEnum.col_cancel.getKey() && state != StateEnum.col_stepBack.getKey() && state != StateEnum.col_pending.getKey() && state != StateEnum.col_done.getKey() && state != StateEnum.col_sent.getKey()
						&& (state != StateEnum.col_waitSend.getKey() || "listSent".equals(from))) { // 已发里被回退的不能删除
					result = WFComponentUtil.getErrorMsgByAffair(affair);
				}
			}
		}

		if (!"".equals(result)) {
			return result;
		}
		return "success";
	}
	@AjaxAccess
	public void deleteAffair(String pageType, long affairId) throws BusinessException {
		govdocManager.deleteAffair(pageType, affairId);
	}
	/**
     * AJAX方法：回退分办
     * @param summaryID
     * @param affairID
     * @return
     * @throws BusinessException
     */
	@AjaxAccess
	public String takeDeal(String summaryID, String affairID) throws BusinessException {
		return govdocManager.takeDeal(summaryID, affairID);
	}
	/**
	 * 记录正文修改日志
	 * @param map
	 */
	@AjaxAccess
	public void recoidChangeWord(Map<String, String> map) {
		govdocManager.recoidChangeWord(map);
	}
	/**
	 * 删除对应的公文意见
	 * @param commentId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String delComment(String commentId) throws BusinessException{
		return govdocCommentManager.delComment(commentId);
	}
	@AjaxAccess
	public Comment insertComment(Comment comment, String openFrom) throws BusinessException {
		return govdocCommentManager.insertComment(comment, openFrom);
	}
	@AjaxAccess
	public Map<String, Object> transTakeBack(Map<String, Object> ma) throws BusinessException {
		return govdocManager.transTakeBack(ma);
	}
	/**
	 * 已发中修改附件，同步附件说明的值
	 * @param filesmName
	 * @param summaryId
	 * @param filesmFileId
	 * @throws BusinessException
	 */
	@AjaxAccess
	public void senderUpdateFilesm(String filesmName, Long summaryId, String filesmFileId) throws BusinessException {
		if(summaryId!=null && Strings.isNotBlank(filesmName) && Strings.isNotBlank(filesmFileId)){
			EdocSummary summary = govdocSummaryManager.getSummaryById(summaryId);
			//更新主表记录
			govdocFormManager.updateFilesmValue(filesmName, summary.getFormAppid(), summary.getFormRecordid(), filesmFileId);
			filesmName = filesmName.replaceAll("\n", "<br>");
			summary.setFilesm(filesmName);
			govdocSummaryManager.saveOrUpdateEdocSummary(summary);
		}	
	}	
	@AjaxAccess
	public GovdocLockObject addFormLock(Long affairId) throws BusinessException {
		return govdocLockManager.formAddLock(affairId,false);
	}	
	@AjaxAccess
	public void delFormLock(Map<String, String> param) throws BusinessException {
		govdocLockManager.ajaxColDelLock(param);
	}
	
	
	/********************************* 操作相关    end **********************************/
	
	
	/********************************* 验证相关 stat **********************************/
	/**
	 * 检查模板是否可用
	 * @param strID
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public Map<String, String> checkTemplateCanUse(String strID) throws BusinessException {
		Map<String, String> result = new HashMap<String, String>();
		if (Strings.isNotBlank(strID)) {// 模板检查
			Long tId = Long.parseLong(strID);
			User user = AppContext.getCurrentUser();
			boolean outMsg = super.templateManager.isTemplateEnabled(tId, user.getId());
			if (!outMsg) {
				result.put("flag", "cannot");
				return result;
			}
		}
		result.put("flag", "can");
		return result;
	}
	
	/**
	 * 验证是否存在联合发文模板
	 * @param accountIds
	 * @return
	 */
	@AjaxAccess
	public String validateAuthTemplate(Long[] accountIds) {
		return govdocTemplateDepAuthManager.validateAuthTemplate(accountIds);
	}
	
    /**
    * 判断当前用户是是否有权限
    * @param resourceCode
    * @return
    * @throws BPMException
    */
	@AjaxAccess
	public boolean checkRoot(String resourceCode) throws BPMException {
		return AppContext.getCurrentUser().hasResourceCode(resourceCode);
	}
	
	@AjaxAccess
	public Boolean checkPishiNo(Integer pishiNo, String pishiName,String pishiYear ,Long summaryId) throws BusinessException {
		return govdocPishiManager.checkPishiNo(pishiNo, pishiName, pishiYear, summaryId);
	}
	/**
	 * 检查模板是否可用
	 * @param strID
	 * @return
	 * @throws BusinessException
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@AjaxAccess
	public Map checkTemplateCanModifyProcess(String templateId) throws BusinessException {
		Map resMap = new HashMap();
		if(!AppContext.getCurrentUser().isV5Member()){//V-Join人员不允许设置督办
            resMap.put("canSetSupervise","no");
        }
		if(!Strings.isNotBlank(templateId)){
			resMap.put("canModify","yes");
			return resMap;
		}
		CtpTemplate ctpTemplate = templateManager.getCtpTemplate(Long.valueOf(templateId));
		if(null  == ctpTemplate){
			resMap.put("canModify","yes");
			return resMap;
		}else{
			String summary = ctpTemplate.getSummary();
			Boolean canSupervise = ctpTemplate.getCanSupervise();
			if(canSupervise!=null && !canSupervise){
				resMap.put("canSetSupervise","no");
				return resMap;
			}
			EdocSummary sum = (EdocSummary)XMLCoder.decoder(summary);
			Boolean canModify = sum.getCanModify();
			if(canModify!=null && canModify){
				resMap.put("canModify","yes");
				return resMap;
			}else{
				resMap.put("canModify","no");
				return resMap;
			}
		}
	}
	
	/**
	 * Ajax前台页面调用，判断是否存在套红模板
	 * @param edocType 类型（正文/文单）
	 * @param bodyType Officeword:word正文/Wpsword:wps正文
	 * @return "0":没有套红模板，“1”：有套红模板
	 */
	@AjaxAccess
	public String hasEdocDocTemplate(String isFromAdmin, Long orgAccountId, String edocType,String bodyType) {
		return govdocDocTemplateManager.hasEdocDocTemplate(orgAccountId, edocType, bodyType);
	}
	@AjaxAccess
	public List<EdocDocTemplate> getEdocDocTemplateList(String isFromAdmin, Long orgAccountId, String edocType, String bodyType) throws BusinessException {
		try {
			User user = AppContext.getCurrentUser();
			return govdocDocTemplateManager.getEdocDocTemplateList(isFromAdmin, orgAccountId, user, edocType, bodyType);
		} catch(Exception e) {
			LOGGER.error("ajax获取套红模板列表异常：",e);
			throw new BusinessException();
		}
	}
	@AjaxAccess
	public String getDocTemplateIdByFormId(Long formId,long userId) throws BusinessException {
		return govdocDocTemplateManager.getDocTemplateIdByFormId(formId, userId);
	}
	@AjaxAccess
	public String getLocalPrintTemplate(Long formId) throws IOException, FileNotFoundException {
		return govdocDocTemplateManager.getLocalPrintTemplate(formId);
	}
	/**
	 * 是否意见不能为空
	 * @param commentId
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String needFillOpinion(String commentId) throws BusinessException {
		if(Strings.isNotBlank(commentId)){
			try{
				CommentManager commentManager = (CommentManager)AppContext.getBean("ctpCommentManager");
				Comment comment = commentManager.getComment(Long.parseLong(commentId));
				
				CtpAffair affair = affairManager.get(comment.getAffairId());
				EdocSummary summary = govdocSummaryManager.getSummaryById(comment.getModuleId());
				Permission permission = permissionManager.getPermission(
						PermissionFatory.getPermBySubApp(summary.getGovdocType()).getCategorty(),
						collaborationApi.getPolicyByAffair(affair).getId(), summary.getOrgAccountId());
				Integer opinion = permission.getNodePolicy().getOpinionPolicy();
	        	if(opinion != null && opinion.intValue() == 1){
	        		return "needFillOpinion";
	        	}
			}catch(Exception e){
				LOGGER.error("获取<是否必填意见选项>失败!");
			}
		}
		return "";
	}

	/**
	 * 判断公文在当前节点是否有策略
	 * @param orgAccountId
	 * @param govdocType
	 * @param affairId
	 * @return
	 */
	@AjaxAccess
	public String hasTransCollStrategy(Long orgAccountId, Integer govdocType, Long affairId ,String operation) {
		try {
			String category = "";
			String nodepolicy = "";
			if(orgAccountId == null){
				orgAccountId = AppContext.currentAccountId();
			}
			CtpAffair affair = affairManager.get(affairId);
			if(govdocType == 1){
				category = EnumNameEnum.edoc_new_send_permission_policy.name();
			}else if(govdocType == 2){
				category = EnumNameEnum.edoc_new_rec_permission_policy.name();
			}else if(govdocType == 3){
				category = EnumNameEnum.edoc_new_qianbao_permission_policy.name();
			}else if(govdocType == 4){
				category = EnumNameEnum.edoc_new_change_permission_policy.name();
			}
			nodepolicy = affair.getNodePolicy();
			PermissionManager permissionManager=(PermissionManager)AppContext.getBean("permissionManager");
			PermissionVO permissionVo = permissionManager.getPermissionVO(category, nodepolicy, orgAccountId);
			String autoOperation = ",TurnRecEdoc,TransmitBulletin";
			
			String advanced = permissionVo.getAdvancedOperation();//节点已选中的高级操作
			String common = permissionVo.getCommonOperation();//节点已选中的常用操作 
			
			if(nodepolicy != null && ("niwen".equals(nodepolicy) || "dengji".equals(nodepolicy))){
				advanced += autoOperation;
			}
			if(Strings.isNotBlank(advanced)){
				String[] advancedOperation = advanced.split(",");
				for (int i=0;i<advancedOperation.length;i++) {				
					if(operation.equals(advancedOperation[i].trim())){					
						return operation;
					}
				}
			}
			if(Strings.isNotBlank(common)){
				String[] commonOperation = common.split(",");
				for (int i=0;i<commonOperation.length;i++) {
					if(operation.equals(commonOperation[i].trim())){
						return operation;
					}
				}
			}
			return "0";
		} catch(Exception e) {
			LOGGER.error("判断公文在当前收文节点是否有转发文操作", e);
		}
		return null;
	}
	@AjaxAccess
	public String verifyUnitExists(String unit,Long summaryId) throws BusinessException {
		String resultNames = "";
		String resultIds = "";
		GovdocExchangeMain main = govdocExchangeManager.findBySummaryId(summaryId, GovdocExchangeMain.EXCHANGE_TYPE_ZHUANSHOUWEN);
		List<GovdocExchangeDetail> details = new ArrayList<GovdocExchangeDetail>();
		if(main != null){
			Map<String, String> conditionMap = new HashMap<String, String>();
			conditionMap.put("mainId", main.getId().toString());
			details = govdocExchangeDao.findGovdocExchangeDetail(new FlipInfo(), conditionMap);
		}

		Map<Long, GovdocExchangeDetail> detailMap = new HashMap<Long, GovdocExchangeDetail>();
		for (GovdocExchangeDetail govdocExchangeDetail : details) {
			detailMap.put(Long.valueOf(govdocExchangeDetail.getRecOrgId()), govdocExchangeDetail);
		}
		String[] unitIds = unit.split(",");
		for (String string : unitIds) {
			Long unitId = Long.valueOf(string.split("\\|")[1]);
			GovdocExchangeDetail govdocExchangeDetail = detailMap.get(unitId);
			if (govdocExchangeDetail != null) {
				if (!"".equals(resultNames)) {
					resultNames += ",";
				}
				if (!"".equals(resultIds)) {
					resultIds += ",";
				}
				resultNames += govdocExchangeDetail.getRecOrgName();
				resultIds += string;
			}
		}
		Map<String, String> map = new HashMap<String, String>();
		//为接下来用户选择否做准备
		if (!"".equals(resultNames)) {
			String[] resultIds2 = resultIds.split(",");

			for (int i = 0; i < unitIds.length; i++) {
				for (int j = 0; j < resultIds2.length; j++) {
					if (resultIds2[j].equals(unitIds[i])) {
						unitIds[i] = null;
					}
				}
			}
			String finalIds = "";
			for (String string : unitIds) {
				if (Strings.isNotBlank(string)) {
					if (!"".equals(finalIds)) {
						finalIds += ",";
					}
					finalIds += string;
				}
			}
			map.put("names", resultNames);
			map.put("finalIds", finalIds);
			return JSONUtil.toJSONString(map);
		}
		return null;
	}
	/**
	 * 根据策略名称，检查公文是否有对于的权限
	 * @param affairId 公文id列表
	 * @param actionKey 策略名称 如撤销(Cancel)\修改正文(Edit)
	 * @return 撤销结果信息
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String getRightByAction(String affairId, String actionKey) throws BusinessException {
		StringBuilder result = new StringBuilder();
		CtpAffair affair = null;
		EdocSummary summary = null;
		List<String> actions = null;
		affair = affairManager.get(Long.parseLong(affairId));
		summary = govdocSummaryManager.getSummaryById(affair.getObjectId());
		long accountId = 0L;
		if (summary != null) {//老公文不做判断
			if(summary.getGovdocType()!=null && summary.getGovdocType().intValue()!=0) {
				accountId = GovdocHelper.getFlowPermAccountId(AppContext.currentAccountId(), summary);
				if("collaboration".equals(affair.getNodePolicy())){
					affair.setNodePolicy("niwen");
				}
				// 获取节点权限的策略
				if (null != affair.getSubApp() && affair.getSubApp() == ApplicationSubCategoryEnum.edoc_shouwen.getKey()) {
					actions = permissionManager.getActionList(EnumNameEnum.edoc_new_rec_permission_policy.name(), affair.getNodePolicy(), accountId);
				} else if (null != affair.getSubApp() && affair.getSubApp() == ApplicationSubCategoryEnum.edoc_jiaohuan.getKey()) {
					actions = permissionManager.getActionList(EnumNameEnum.edoc_new_change_permission_policy.name(), affair.getNodePolicy(), accountId);
				} else if (null != affair.getSubApp() && affair.getSubApp() == ApplicationSubCategoryEnum.edoc_qianbao.getKey()) {
					actions = permissionManager.getActionList(EnumNameEnum.edoc_new_qianbao_permission_policy.name(), affair.getNodePolicy(), accountId);
				} else {
					actions = permissionManager.getActionList(EnumNameEnum.edoc_new_send_permission_policy.name(), affair.getNodePolicy(), accountId);
				}
				//判断是否有对应的策略
				if (Strings.isNotEmpty(actions) && actions.contains(actionKey)) {
					if("Archive".equals(actionKey)&&Boolean.FALSE.equals(summary.getCanArchive())){
						result.append(ResourceUtil.getString("govdoc.official.document") + summary.getSubject() + ResourceUtil.getString("govdoc.archive.notAllowed")+"\r\n");
					}else{
						result.append("true");
					}
				} else {
					if("Cancel".equals(actionKey))
						result.append(ResourceUtil.getString("govdoc.official.document") + summary.getSubject() + ResourceUtil.getString("govdoc.revocationProcess.notAllowed")+"\r\n");
					else if("TransmitBulletin".equals(actionKey))
						result.append(ResourceUtil.getString("govdoc.official.document") + summary.getSubject() + ResourceUtil.getString("govdoc.revocationProcess.notAllowed")+ "\r\n");
					else if("Archive".equals(actionKey))
						result.append(ResourceUtil.getString("govdoc.official.document") + summary.getSubject() + ResourceUtil.getString("govdoc.archive.notAllowed")+"\r\n");
						
				}
			} else {
				result.append("true");
			}
		}
		return result.toString();
	}
	
	/**
	 * 根据affair检查当前节点是否有对应的策略
	 * @param affairId
	 * @param nodePolicyName
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public boolean hasNodePolicy(Long affairId, String nodePolicyName) throws BusinessException {
		CtpAffair affair = affairManager.get(affairId);
		if (affair != null) {
			EdocSummary summary = govdocSummaryManager.getSummaryById(affair.getObjectId());
			Long flowPermAccountId = GovdocHelper.getFlowPermAccountId(affair.getOrgAccountId(), summary);
			// 封装节点权限
			String configItem = collaborationApi.getPolicyByAffair(affair).getId();
			String category = PermissionFatory.getPermBySubApp(summary.getGovdocType(), configItem).getCategorty();
			Permission permission = permissionManager.getPermission(category, configItem, flowPermAccountId);
			List<String> basicActionList = permissionManager.getActionList(permission, PermissionAction.basic);
			List<String> commonActionList = permissionManager.getActionList(permission, PermissionAction.common);
			List<String> advanceActionList = permissionManager.getActionList(permission, PermissionAction.advanced);
			return basicActionList.contains(nodePolicyName) || commonActionList.contains(nodePolicyName) || advanceActionList.contains(nodePolicyName);
		}
		return false;
	}
	
	/********************************* 验证相关 stat **********************************/
	
	
	/********************************* 归档相关 stat **********************************/
	/**
	 * 检查公文是否能归档
	 * @param collIds 协同id列表
	 * @return 归档结果信息
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String getPigeonholeRight(List<String> collIds) throws BusinessException {
		return govdocDocManager.getPigeonholeRight(collIds);
	}
	@AjaxAccess
	public String getIsSamePigeonhole(List<String> collIds, Long destFolderId) throws BusinessException {
		return govdocDocManager.getIsSamePigeonhole(collIds, destFolderId);
	}
	/**
	 * 验证是否归档
	 * @param collIds 公文id列表
	 * @param destFolderId 目标文件夹ID
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public String checkPigeonhole(List<String> ids, Long floder, String pageType) {
		return govdocDocManager.checkPigeonhole(ids, floder, pageType);
	}
	@AjaxAccess
	public String transPigeonhole(Long affairId, Long destFolderId, String type) throws BusinessException {
		return govdocDocManager.transPigeonhole(affairId, destFolderId, type);
	}
	@AjaxAccess
	public String transPigeonholeDeleteStepBackDoc(List<String> collIds, Long destFolderId) throws BusinessException {
		return govdocDocManager.transPigeonholeDeleteStepBackDoc(collIds, destFolderId);
	}

	@AjaxAccess
	public String checkPigeonhole(Long summaryId, Long floder) {
		return govdocDocManager.checkPigeonhole(summaryId, floder);
	}
	/********************************* 归档相关    end **********************************/
	
	
	/********************************* 工具相关 start **********************************/
	/**
	 * 获取指定分钟数后的日期
	 * @param params
	 * @return
	 * @throws BusinessException
	 */
	@AjaxAccess
	public Long calculateWorkDatetime(Map<String, String> params) throws BusinessException {
		return GovdocHelper.calculateWorkDatetime(params, AppContext.currentAccountId());
	}

	/**
	 * 获取当前流程节点的处理说明
	 * @param AFFAIRID 
	 * @param templeteId 协同模版Id
	 * @param PROCESSID 流程ID
	 * @return 处理说明String
	 */
	@AjaxAccess
	public String getDealExplain(Map<String, String> params) {
	    String affairId = (String) params.get("affairId");
	    String templeteId = (String) params.get("templeteId");
	    String processId = (String) params.get("processId");
        String desc = "";
        if(Strings.isBlank(affairId) || Strings.isBlank(templeteId) || Strings.isBlank(processId)) {
            return desc ;
        }
        /*try{
            CtpAffair affair  = affairManager.get(Long.valueOf(affairId));
            BPMProcess process =  wapi.getBPMProcessForM1(processId);
            BPMActivity activity = process.getActivityById(affair.getActivityId().toString());
            desc = activity.getDesc();
            desc= desc.replaceAll("\r\n", "<br>").replaceAll("\r", "<br>").replaceAll("\n", "<br>").replaceAll("\\s", "&nbsp;");
        }catch(Exception e){
            LOG.error("",e);
        }*/
        return desc;
	}
	@AjaxAccess
	public List<GovdocWorkflowVO> selectMember4OprationChangeProcess(String typeAndIds,Long currentWorkItemId,Long formRecordId) throws BusinessException {
		return GovdocOrgHelper.transGovdocWorkflowVO(typeAndIds);
	}
	/********************************* 工具相关    end **********************************/

	/********************************* 菜单资源相关    start **********************************/
	/**
	 * 资源名称唯一检查
	 * @param resourceName
	 * @return
	 */
	@AjaxAccess
	public boolean isExistence(String resourceId,String resourceName) {
		return privilegeConfigManager.isExistence(resourceId,resourceName);
	}

	@AjaxAccess
	public String getNodePermissionItems() {
		List<Permission> list = new ArrayList<Permission>();
		List<Permission> tmpList;
		long accountId = AppContext.isGroupAdmin()?1l:AppContext.currentAccountId();
		//查询发文
		try {
			tmpList = permissionManager.getPermissionsByCategory(EnumNameEnum.edoc_new_send_permission_policy.name(), accountId);
			list.addAll(tmpList);
//		//查询收文
			tmpList = permissionManager.getPermissionsByCategory(EnumNameEnum.edoc_new_rec_permission_policy.name(), accountId);
			list.addAll(tmpList);
//		//查询 签报
			tmpList = permissionManager.getPermissionsByCategory(EnumNameEnum.edoc_new_qianbao_permission_policy.name(), accountId);
			list.addAll(tmpList);
//		//查询 交换
			tmpList = permissionManager.getPermissionsByCategory(EnumNameEnum.edoc_new_change_permission_policy.name(), accountId);
			list.addAll(tmpList);
		} catch (BusinessException e) {
			LOGGER.error("ajax获取节点权限异常：",e);
			e.printStackTrace();
		}
		return JSONUtil.toJSONString(list);
	}
	/********************************* 菜单资源相关    end **********************************/
	
	/********************************* 查询花脸    end **********************************/
	@AjaxAccess
	public String findBackFileIds(String fileId){
		int ic = 0;
		String ids = "";
		// List<V3XFile> fs=fileManager.findByFileName("copy"+fn);
		List<V3XFile> fs = new ArrayList<V3XFile>();
		List<Long> obfList = new ArrayList<Long>();
		if(fileId.indexOf(".") != -1){
			fileId = fileId.substring(0,fileId.indexOf("."));
		}
		if (NumberUtils.isNumber(fileId)) {//fn是文件Id,不是文件名时
			obfList = officeBakFileManager.getOfficeBakFileIds(Long.parseLong(fileId));
		}
		try {
			Long[] fileIds = null;
			if (obfList.size() > 0) {
				fileIds = new Long[obfList.size()];
				for (int i = 0; i < obfList.size(); i++) {
					fileIds[i] = obfList.get(i);
				}
				fs = fileManager.getV3XFile(fileIds);
			}
			//花脸根据时间进行倒序显示
			Collections.sort(fs,  new Comparator<V3XFile>(){
				@Override
				public int compare(V3XFile o1, V3XFile o2) {
					if(o1.getCreateDate().before(o2.getCreateDate())){
						return 1;
					}
					return -1;
				}
			});
			
			for (V3XFile tempFile : fs) {
				if (ic != 0) {
					ids += ",";
				}
				ic++;
				ids += tempFile.getId();
			}
		} catch (BusinessException e) {
			LOGGER.error("findBackFileIds报错", e);
		}
		return ids;
	}
	/********************************* 查询花脸    end **********************************/

	@AjaxAccess
	public String checkAppointStepback(String activityId,String processId,String caseId,String theStepBackNodeId,String exchangeSendAffairId){
		try {
			BPMProcess process = wapi.getBPMProcess(processId, Long.parseLong(caseId));
			BPMActivity activity = process.getActivityById(theStepBackNodeId);
			CtpAffair exchangeAffair = affairManager.get(Long.parseLong(exchangeSendAffairId));
			if(exchangeAffair != null&& exchangeAffair.getActivityId() != null && activity != null && activity instanceof BPMHumenActivity)
			{
				if("faxing".equals(activity.getSeeyonPolicy().getId()))
				{
					return "0";
				}
				List<BPMHumenActivity> childList = WorkflowUtil.getAllChildHumens((BPMHumenActivity)activity);
				if(childList != null && !childList.isEmpty())
				{
					for(BPMHumenActivity temp : childList)
					{
						if("faxing".equals(temp.getSeeyonPolicy().getId()) && temp.getId().equals(exchangeAffair.getActivityId().toString()))
						{
							return "0";
						}
					}

				}

			}
		} catch (Exception e) {
			return "0";
		}
		return "1";
	}
	
	@AjaxAccess
	public void saveUpdateContentLog(Map<String, String> params){
		govdocManager.saveUpdateContentLog(params);
	}

	@AjaxAccess
	public String findLastBackFileId(Long summaryId,Long contentId) throws BusinessException {
		EdocSummary summary  = govdocSummaryManager.getSummaryById(summaryId);
		if(summary != null && summary.getOriginalContentId() == null){
			List<V3XFile> hualianList = govdocContentManager.findBackFileIds(contentId.toString());
			Collections.sort(hualianList,  new Comparator<V3XFile>(){
				@Override
				public int compare(V3XFile o1, V3XFile o2) {
					if(o1.getCreateDate().before(o2.getCreateDate())){
						return 1;
					}
					return -1;
				}
			});
			return hualianList.get(0).getId().toString();
		}else{
			return "";
		}
	}

	@AjaxAccess
	public String getCanReturnFlag(Long affairId,String exchangeSendAffairId){
		try{
			CtpAffair affairExchange = affairManager.get(Long.parseLong(exchangeSendAffairId));
			CtpAffair affair = affairManager.get(affairId);
			String processId = affair.getProcessId();
			List<CtpAffair> affairs = null;
			EdocSummary summary = govdocSummaryManager.getSummaryById(affair.getObjectId());
			if(Strings.isBlank(processId))
			{
				processId = summary.getProcessId();
			}

			if(affairExchange != null && Strings.isNotBlank(processId) && affairExchange.getActivityId() != null)
			{
				affairs = affairManager.getAffairs(affairExchange.getObjectId());
				BPMProcess process = wapi.getBPMProcess(processId, affair.getCaseId());

				BPMActivity currentAffairActivity  = process.getActivityById(affair.getActivityId().toString());
				if(currentAffairActivity != null)
				{

					BPMCase bpmCase  = wapi.getBPMCaseByProcessId(affair.getProcessId());
					Map<String, String[]> nodesStatus = caseManager.getNodesStatus(bpmCase.getId());
					Map<String, List<String[]>> nodesItemsStatus = workItemManager.getNodesItemsStatus(bpmCase.getId(),nodesStatus);
					List<BPMHumenActivity>  currentAffairParents = WorkflowUtil.getParentHumens(bpmCase, currentAffairActivity, nodesItemsStatus);
					if(currentAffairParents != null && !currentAffairParents.isEmpty())
					{
						for(BPMHumenActivity parentActivity : currentAffairParents)
						{

							for(CtpAffair ctpAffairTemp :affairs)
							{
								if(ctpAffairTemp.getActivityId() != null && parentActivity.getId().equals(ctpAffairTemp.getActivityId().toString()))
								{
									if(isFensong(ctpAffairTemp,summary))
									{
										return "0";
									}
								}

							}

							List<BPMHumenActivity> childList = WorkflowUtil.getAllChildHumens(parentActivity);

							if(childList != null && !childList.isEmpty())
							{
								for(BPMHumenActivity temp : childList)
								{

									for(CtpAffair ctpAffairTemp :affairs)
									{
										if(ctpAffairTemp.getActivityId() != null &&  temp.getId().equals(ctpAffairTemp.getActivityId().toString()))
										{
											if(temp.getId().equals(affairExchange.getActivityId().toString()))
											{
												return "0";
											}
										}

									}
								}

							}

						}

					}
				}


			}

		}catch (Exception e){
			return "0";
		}
		return "1";
	}

	public boolean isFensong(CtpAffair affair,EdocSummary summary)
	{
		try{
			if(affair.getActivityId() == null || affair.getOrgAccountId() == null){
				return  false;
			}

			if(affair.getNodePolicy() == "faxing")
			{
				return true;
			}
			String configItem = collaborationApi.getPolicyByAffair(affair).getId();
			if(Strings.isBlank(configItem))
			{
				return  false;
			}
			String category = PermissionFatory.getPermBySubApp(summary.getGovdocType(), configItem).getCategorty();
			if(Strings.isBlank(category))
			{
				return  false;
			}
			Permission permission = null;
			// 如果是调用的模板，那么需要取对应模板的orgAccountId查询对应的节点权限，否则查询对应当前登陆人的AccountId。
			Long orgAccountId = AppContext.currentAccountId();
			if (affair.getTempleteId() != null) {
				CtpTemplate ctpTemplate = templateManager.getCtpTemplate(affair.getTempleteId());
				if (ctpTemplate!=null) {
					orgAccountId = ctpTemplate.getOrgAccountId();
				}
			}
			if(orgAccountId != null)
			{
				permission = permissionManager.getPermission(category, configItem,orgAccountId);
				if (permission != null) {
					String baseAction = permission.getBasicOperation();
					if (baseAction.indexOf("FaDistribute") != -1) {
						return true;
					}

				}
			}

		}catch (Exception e){
			LOGGER.error("获取节点权限失败",e);
		}
		return false;
	}
	/**
	 * 
	 */
	@AjaxAccess
	public String transbuildCacheUrl(Long fileId){
		boolean officeTransformConversion = OfficeTransHelper.isOfficeTran();
		if(officeTransformConversion){
			V3XFile v3XFile = null;
			try {
				v3XFile = fileManager.getV3XFile(fileId);
			} catch (Exception e) {}

			if (OfficeTransHelper.allowTrans(v3XFile)) {
				String htmlURL = OfficeTransHelper.buildCacheUrl(v3XFile, false);
				return "<script>trans2Html=true;</script>" + "<iframe id=\"officeTransIframe\" style=\"width:100%;height:100%;\" src=\"" + htmlURL + "\"></iframe>";
			}
		}
		return "";
	}
	
	public void setCtpMainbodyManager(MainbodyManager ctpMainbodyManager) { this.ctpMainbodyManager = ctpMainbodyManager; }
	public void setGovdocDocTemplateManager(GovdocDocTemplateManager govdocDocTemplateManager) { this.govdocDocTemplateManager = govdocDocTemplateManager; }
	public void setAffairManager(AffairManager affairManager) { this.affairManager = affairManager; }
	public void setGovdocSummaryManager(GovdocSummaryManager govdocSummaryManager) { this.govdocSummaryManager = govdocSummaryManager; }
	public void setWpsTransManager(WpsTransManager wpsTransManager) { this.wpsTransManager = wpsTransManager; }
	public void setGovdocExchangeManager(GovdocExchangeManager govdocExchangeManager) { this.govdocExchangeManager = govdocExchangeManager; }
	public void setGovdocFormManager(GovdocFormManager govdocFormManager) { this.govdocFormManager = govdocFormManager; }
	public void setPermissionManager(PermissionManager permissionManager) { this.permissionManager = permissionManager; }
	public void setCollaborationApi(CollaborationApi collaborationApi) { this.collaborationApi = collaborationApi; }
	public void setGovdocCommentManager(GovdocCommentManager govdocCommentManager) { this.govdocCommentManager = govdocCommentManager; }
	public void setGovdocPishiManager(GovdocPishiManager govdocPishiManager) { this.govdocPishiManager = govdocPishiManager; }
	public void setGovdocLockManager(GovdocLockManager govdocLockManager) { this.govdocLockManager = govdocLockManager; }
	public void setV3xHtmDocumentSignatManager(V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager) { this.v3xHtmDocumentSignatManager = v3xHtmDocumentSignatManager; }
	public void setGovdocManager(GovdocManager govdocManager) { this.govdocManager = govdocManager; }
	public void setGovdocExchangeDao(GovdocExchangeDao govdocExchangeDao) { this.govdocExchangeDao = govdocExchangeDao; }
	public void setConfigManager(ConfigManager configManager) { this.configManager = configManager; }
	public void setGovdocDocManager(GovdocDocManager govdocDocManager) {this.govdocDocManager = govdocDocManager;}
	public void setGovdocExchangeAccountManager(GovdocExchangeAccountManager govdocExchangeAccountManager) { this.govdocExchangeAccountManager = govdocExchangeAccountManager; }
	public void setGovdocTemplateDepAuthManager(GovdocTemplateDepAuthManager govdocTemplateDepAuthManager) { this.govdocTemplateDepAuthManager = govdocTemplateDepAuthManager; }
	@Override
    public void setGovdocContentManager(GovdocContentManager govdocContentManager) { this.govdocContentManager = govdocContentManager; }
	public PrivilegeConfigManager getPrivilegeConfigManager() { return privilegeConfigManager; }
	public void setPrivilegeConfigManager(PrivilegeConfigManager privilegeConfigManager) {	this.privilegeConfigManager = privilegeConfigManager; }
	public void setOfficeBakFileManager(OfficeBakFileManager officeBakFileManager) {this.officeBakFileManager = officeBakFileManager;}
	public void setFileManager(FileManager fileManager) {this.fileManager = fileManager;}
	public void setWapi(WorkflowApiManager wapi) {
		this.wapi = wapi;
	}

	public void setWorkItemManager(WorkItemManager workItemManager) {
		this.workItemManager = workItemManager;
	}

	public void setCaseManager(CaseManager caseManager) {
		this.caseManager = caseManager;
	}
}
