package com.seeyon.apps.govdoc.manager.impl;

import com.seeyon.apps.collaboration.enums.ColHandleType;
import com.seeyon.apps.edoc.bo.EdocOptionBO;
import com.seeyon.apps.govdoc.bo.PishiInputObject;
import com.seeyon.apps.govdoc.dao.GovdocPishiDao;
import com.seeyon.apps.govdoc.dao.PishiDealDao;
import com.seeyon.apps.govdoc.helper.GovdocContentHelper;
import com.seeyon.apps.govdoc.helper.GovdocNewHelper;
import com.seeyon.apps.govdoc.manager.GovdocCommentManager;
import com.seeyon.apps.govdoc.manager.GovdocFormManager;
import com.seeyon.apps.govdoc.manager.GovdocLogManager;
import com.seeyon.apps.govdoc.manager.GovdocManager;
import com.seeyon.apps.govdoc.manager.GovdocPishiManager;
import com.seeyon.apps.govdoc.manager.GovdocProcessManager;
import com.seeyon.apps.govdoc.manager.GovdocSummaryManager;
import com.seeyon.apps.govdoc.manager.GovdocTransInstructionManager;
import com.seeyon.apps.govdoc.option.util.EdocOptionDisplayUtil;
import com.seeyon.apps.govdoc.po.FormOptionExtend;
import com.seeyon.apps.govdoc.po.GovdocLeaderSerialShortname;
import com.seeyon.apps.govdoc.po.PishiDeal;
import com.seeyon.apps.govdoc.vo.GovdocDealVO;
import com.seeyon.apps.govdoc.vo.GovdocPishiVO;
import com.seeyon.apps.govdoc.vo.MemberPostVO;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.ModuleType;
import com.seeyon.ctp.common.affair.manager.AffairManager;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.cache.CacheAccessable;
import com.seeyon.ctp.common.cache.CacheFactory;
import com.seeyon.ctp.common.cache.CacheMap;
import com.seeyon.ctp.common.content.affair.constants.StateEnum;
import com.seeyon.ctp.common.content.affair.constants.SubStateEnum;
import com.seeyon.ctp.common.content.comment.Comment;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.common.po.content.CtpContentAll;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.common.taglibs.functions.Functions;
import com.seeyon.ctp.common.template.manager.TemplateManager;
import com.seeyon.ctp.form.api.FormApi4Cap3;
import com.seeyon.ctp.organization.OrgConstants;
import com.seeyon.ctp.organization.bo.MemberPost;
import com.seeyon.ctp.organization.bo.V3xOrgAccount;
import com.seeyon.ctp.organization.bo.V3xOrgDepartment;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.bo.V3xOrgPost;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.util.DateUtil;
import com.seeyon.ctp.util.Strings;
import com.seeyon.ctp.util.UUIDLong;
import com.seeyon.ctp.util.annotation.AjaxAccess;
import com.seeyon.v3x.edoc.dao.EdocOpinionDao;
import com.seeyon.v3x.edoc.domain.EdocSummary;
import com.seeyon.v3x.edoc.webmodel.EdocOpinionModel;
import com.seeyon.v3x.edoc.webmodel.FormOpinionConfig;
import com.seeyon.v3x.system.signet.domain.V3xHtmDocumentSignature;
import com.seeyon.v3x.system.signet.enums.V3xHtmSignatureEnum;
import com.seeyon.v3x.system.signet.manager.V3xHtmDocumentSignatManager;
import net.sf.json.JSONObject;
import net.sf.json.JsonConfig;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class GovdocTransInstructionManagerImpl implements GovdocTransInstructionManager {
	
	private static final Log LOGGER = LogFactory.getLog(GovdocTransInstructionManagerImpl.class);
    private GovdocPishiManager govdocPishiManager;
    private GovdocPishiDao govdocPishiDao;
    private GovdocCommentManager govdocCommentManager;
    private GovdocSummaryManager govdocSummaryManager;
    private AffairManager affairManager;
    private OrgManager orgManager;
    private EdocOpinionDao edocOpinionDao;
    private GovdocFormManager govdocFormManager;
    private V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager;
	private TemplateManager templateManager;
	private GovdocManager govdocManager;
	private PishiDealDao pishiDealDao;


	public TemplateManager getTemplateManager() {
		return templateManager;
	}


	public void setTemplateManager(TemplateManager templateManager) {
		this.templateManager = templateManager;
	}

	public GovdocManager getGovdocManager() {
		return govdocManager;
	}

	public void setGovdocManager(GovdocManager govdocManager) {
		this.govdocManager = govdocManager;
	}

    public void setV3xHtmDocumentSignatManager(V3xHtmDocumentSignatManager v3xHtmDocumentSignatManager) {
        this.v3xHtmDocumentSignatManager = v3xHtmDocumentSignatManager;
    }


    public void setGovdocFormManager(GovdocFormManager govdocFormManager) {
        this.govdocFormManager = govdocFormManager;
    }

    public void setEdocOpinionDao(EdocOpinionDao edocOpinionDao) {
        this.edocOpinionDao = edocOpinionDao;
    }

    public void setOrgManager(OrgManager orgManager) {
        this.orgManager = orgManager;
    }

    public void setAffairManager(AffairManager affairManager) {
        this.affairManager = affairManager;
    }

    public void setGovdocSummaryManager(GovdocSummaryManager govdocSummaryManager) {
        this.govdocSummaryManager = govdocSummaryManager;
    }

    public void setGovdocCommentManager(GovdocCommentManager govdocCommentManager) {
        this.govdocCommentManager = govdocCommentManager;
    }

    public void setGovdocPishiDao(GovdocPishiDao govdocPishiDao) {
        this.govdocPishiDao = govdocPishiDao;
    }

    public void setGovdocPishiManager(GovdocPishiManager govdocPishiManager) {
        this.govdocPishiManager = govdocPishiManager;
    }

    @Override
    public List<PishiDeal> getPishiList(long summaryId){
    	Long userId = AppContext.getCurrentUser().getId();
    	if(Long.valueOf(summaryId)==null) {
			return null;
		}
    	List<PishiDeal> opinionlist = pishiDealDao.getPishiDealBySummaryId(summaryId);
		if(opinionlist!=null&&opinionlist.size()>0) {
			return opinionlist;
		}
		return null;
    }
    @Override
    public GovdocPishiVO getPishiNo(Long memberId) throws BusinessException {
        GovdocPishiVO pishiVo = new GovdocPishiVO();
        Object pishiname = govdocPishiManager.getLSS(memberId);
        if (pishiname == null || "".equals(pishiname)) {
            return pishiVo;
        }
        pishiVo.setPishiname(pishiname);
        Integer nowyear = Calendar.getInstance().get(Calendar.YEAR);
        List<Integer> pishiyear = new ArrayList<Integer>();
        List<String> pishiyears = new ArrayList<String>();
		for(Integer i=nowyear; i>=2016; i--) {
			pishiyear.add(i);
			pishiyears.add(i.toString());
		}
        pishiVo.setNowyear(nowyear);
        pishiVo.setPishiyear(pishiyear);
        Map<String, Integer> pishiNos = govdocPishiDao.findPishinoMap(pishiname.toString(), pishiyears);
        JsonConfig config = new JsonConfig();
        String rs = JSONObject.fromObject(pishiNos, config).toString();
        pishiVo.setPishiNos(rs);
        Date date = new Date();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        String time = format.format(date);
        pishiVo.setProxydate(time);
        return pishiVo;
    }

    @Override
    public Map<String, Object> saveLeaderInput(List<Map<String, String>> param, Long summaryId, Long affairId) throws BusinessException {
    	Map<String,Object> result=new HashMap<String, Object>();
		EdocSummary summary = govdocSummaryManager.getSummaryById(summaryId);
		CtpAffair affair = affairManager.get(affairId);
		if(affair==null) {
			affair = affairManager.getSenderAffair(summaryId);
		}
		List<Long> affairIds = new ArrayList<Long>();
		Map<String, String> affairPishiMap = new HashMap<String, String>();
		ArrayList<Comment> comments = new ArrayList<Comment>();
		List<PishiDeal> dealList = new ArrayList<PishiDeal>();
		long maxSortId = 0;
		if (param != null &&!param.isEmpty()) {
			List<PishiDeal> pishiDealList = pishiDealDao.findBy("summaryId", summaryId);

			if(!pishiDealList.isEmpty())
			{
				for(PishiDeal deal:pishiDealList) {
					if(deal.getSortId() != null && maxSortId< deal.getSortId())
					{
						maxSortId = deal.getSortId();
					}
				}
			}
			for (Map<String, String> map : param) {
				PishiDeal pishiDeal = getPishiDeal(map);
				//PishiInputObject pishiInputObject = getPishiInputObject(map);
				String pishiUserId = pishiDeal.getPishiUser().toString();
				if("1".equals(map.get("isSave"))) {
					for(PishiDeal deal:pishiDealList) {
						if(deal.getPishiUser().toString().equals(pishiUserId)&&deal.getNum().equals(pishiDeal.getNum())) {
							deal.setAttitude(pishiDeal.getAttitude());
							deal.setAttitudeCode(pishiDeal.getAttitudeCode());
							deal.setPishiDate(deal.getPishiDate());
							deal.setPostInfo(pishiDeal.getPostInfo());
							
							pishiDeal = deal;
							continue;
						}
					}
					String affairIdStr =pishiDeal.getAffairId()==null?"":pishiDeal.getAffairId().toString();
					if(Strings.isNotBlank(affairIdStr)) {
						affairIds.add(pishiDeal.getAffairId());
						if(edocOpinionDao.findEdocOpinionByAffairId(pishiDeal.getAffairId()).isEmpty())
						{
							CtpAffair newAffair = saveAffair(affair, pishiDeal);
							// 保存流程意见、表单意见
							Comment comment = saveComment(pishiDeal, newAffair, summary);
							comments.add(comment);
						}
						else {

							// 保存意见
							Comment comment = new Comment();
							comment.setId(UUIDLong.longUUID());
							comment.setContent(pishiDeal.getPishiOpinion());
							comment.setModuleId(summary.getId());
							comment.setAffairId(Long.valueOf(affairIdStr));
							comment.setModuleType(ModuleType.edoc.getKey());
							comment.setPid(0l);
							//设置态度
							comment.setExtAtt1(pishiDeal.getAttitude());
							comment.setExtAtt4(pishiDeal.getAttitudeCode());
							comment.setRelateInfo("[]");
							String pishiUserName = Functions.showMemberName(pishiDeal.getPishiUser());
							comment.setCreateName(pishiUserName);
							comment.setCreateId(pishiDeal.getPishiUser());
							comments.add(comment);
						}

					}
					dealList.add(pishiDeal);
					continue;
				}
				if("1".equals(map.get("update"))) {
					for(PishiDeal deal:pishiDealList) {
						if(deal.getPishiUser().toString().equals(pishiUserId)&&deal.getNum().equals(pishiDeal.getNum())) {
							pishiDeal.setSortId(deal.getSortId());
							break;
						}
					}
					this.deleteLeaderInput(pishiDeal.getId());
				}
				// 生成批示人新affair
				CtpAffair newAffair = saveAffair(affair, pishiDeal);
				// 保存流程意见、表单意见
				Comment comment = saveComment(pishiDeal, newAffair, summary);
				affairIds.add(newAffair.getId());
				comments.add(comment);
				//存放affairId与代录人ID对应关系，用于删除缓存时使用 userId+summary+""
				affairPishiMap.put(String.valueOf(pishiDeal.getPishiUser())+summaryId+""+map.get("num"), String.valueOf(newAffair.getId()));
				//缓存affair对应pishiUser用于删除代录意见
				pishiDeal.setSummaryId(summaryId);
				pishiDeal.setAffairId(newAffair.getId());
				pishiDeal.setId(UUIDLong.longUUID());
				if(pishiDeal.getSortId() == null)
				{
					maxSortId = maxSortId + 1;
					pishiDeal.setSortId(maxSortId);
				}

				//pishiDeal.setPishiDate(new Date());
				dealList.add(pishiDeal);
				pishiDealDao.save(pishiDeal);
			}
		}
		//组装新的意见对象，用于页面刷新文单意见
		EdocOptionBO retOptionBO = new EdocOptionBO();
		//设置文单意见对象
		FormOptionExtend formOptionExtend = govdocFormManager.getFormOptionExtend(summary.getFormAppid());
		FormOpinionConfig displayConfig = govdocFormManager.getFormOpinionConfig(formOptionExtend);
		Map<String,EdocOpinionModel> maps = govdocFormManager.getGovdocOpinion(summary.getFormAppid(), summary, displayConfig);
		List<Comment> commentList = new ArrayList<Comment>();
        commentList = govdocCommentManager.getCommentList(ModuleType.edoc, summaryId);
		for (Comment comment : comments) {
			commentList.add(comment);
		}
		
		List<V3xHtmDocumentSignature> signatuers = v3xHtmDocumentSignatManager.findBySummaryIdAndType(summaryId, V3xHtmSignatureEnum.HTML_SIGNATURE_DOCUMENT.getKey());
		 Map<String, Object> strMap = EdocOptionDisplayUtil.convertOpinionToString(maps,displayConfig,affair,true,signatuers,commentList);
        retOptionBO.setOpinionsJs(EdocOptionDisplayUtil.optionToJs(strMap));
		            
        //发起人意见
        retOptionBO.setSenderOpinion(strMap.get("senderOpinionList"));
        retOptionBO.setSenderOpinionAttStr(strMap.get("senderOpinionAttStr"));
		result.put("opinionBo", retOptionBO);
		
		result.put("code", 1);
		result.put("affairIds",affairIds);
		result.put("affairIdMap", affairPishiMap);
		result.put("pishiList", dealList);
		return result;
    }
    

    /**
     * 删除代录批示
     * @param param
     * @return 成功：success，失败：errorMessage
     * @throws BusinessException
     */
    public String deleteLeaderInput(Long id) throws BusinessException{
        if (id == null) {
    	   return "false";
	    }
        PishiDeal pishiDeal = pishiDealDao.get(id);
        //affairManager.deleteAffair(pishiDeal.getAffairId());
        
        edocOpinionDao.deleteDealOpinionByAffairId(pishiDeal.getAffairId());//删除意见
        govdocPishiDao.deletePishiNoByAffairId(pishiDeal.getAffairId(), null);//删除批示编号
        pishiDealDao.delete(id); //删除批示处理
//    	Long userId = AppContext.getCurrentUser().getId();
//    	ArrayList<PishiDeal> originList = pishiDealCacheMap.get(summaryId+userId+"");
//		if(originList!=null&&originList.size()>0) {
//			for(PishiDeal deal:originList) {
//				if(!String.valueOf(deal.getPishiUser()).isEmpty()&&String.valueOf(deal.getPishiUser())!=null){
//					if((deal.getPishiUser().toString()).equals(pishiUserId)&&deal.getNum() == Integer.valueOf(num)){
//						originList.remove(deal);
//						
//						break;
//					}
//				}
//			}
//		}
//		if(pishiDealAffairCacheMap.contains(pishiUserId+String.valueOf(summaryId)+""+num)){
//			String pishiAffair = pishiDealAffairCacheMap.get(pishiUserId+String.valueOf(summaryId)+""+num);
//			//删除数据库代录记录
//			edocOpinionDao.deleteDealOpinionByAffairId(Long.valueOf(pishiAffair));
//			pishiDealAffairCacheMap.remove(pishiUserId+String.valueOf(summaryId)+""+num);
//		}	
//		if(pishiDealCacheMap.contains(summaryId+userId+"")) {
//			pishiDealCacheMap.remove(summaryId+userId+"");
//		}
//		pishiDealCacheMap.put(summaryId+userId+"", originList);
    	return "success";
    }
      
    
    /**
	 * 
	 * @param pishiUserId
	 *            批示人ID
	 * @param opinion
	 *            批示内容
	 * @param pishiYear
	 *            批示编号 年
	 * @param pishiNo
	 *            批示编号 号
	 * @param pishiDate
	 *            批示日期
	 * @throws BusinessException
	 */
	private Comment saveComment(PishiDeal pishiInputObject, CtpAffair newAffair, EdocSummary summary)
			throws BusinessException {
		// 保存意见
		Comment comment = new Comment();
		comment.setId(UUIDLong.longUUID());
		comment.setContent(pishiInputObject.getPishiOpinion() + "(由" + AppContext.currentUserName() + "代录)");
		comment.setModuleId(summary.getId());
		comment.setAffairId(newAffair.getId());
		comment.setModuleType(ModuleType.edoc.getKey());
		comment.setPid(0l);
		//设置态度
		comment.setExtAtt1(pishiInputObject.getAttitude());
		comment.setExtAtt4(pishiInputObject.getAttitudeCode());
		comment.setRelateInfo("[]");
		String pishiUserName = Functions.showMemberName(pishiInputObject.getPishiUser());
		pishiInputObject.setPishiUserName(pishiUserName);
		comment.setCreateName(pishiUserName);
		comment.setCreateId(pishiInputObject.getPishiUser());
//		try {
//			govdocCommentManager.insertComment(comment, newAffair);
//		} catch (BusinessException e) {
//			e.printStackTrace();
//		}
		/*
		 * Map<String, Object> commentFields = new HashMap<String, Object>();
		 * commentFields.put("createId", pishiInputObject.getPishiUser());
		 * commentFields.put("createDate", pishiInputObject.getPishiDate());
		 * govdocCommentManager.updateFields(comment.getId(), commentFields);
		 */

		//保存领导批示
		Map<String ,Long> map = new HashMap<String, Long>();
		map.put("leaderId", pishiInputObject.getPishiUser());
		List<GovdocLeaderSerialShortname> pishiSerialNoConfig = govdocPishiDao.getGovdocLSSs(null, map);
		String pishiName=null;
		if(pishiSerialNoConfig!=null&&!pishiSerialNoConfig.isEmpty()){
		
			pishiName=pishiSerialNoConfig.get(0).getShortName();
		}
		if(Strings.isNotEmpty(pishiInputObject.getPishiYear())){
			if(!govdocPishiManager.checkPishiNo(Integer.parseInt(pishiInputObject.getPishiNo()), pishiName, pishiInputObject.getPishiYear(), summary.getId())){
				throw new BusinessException("领导批示编号重复，请重新选择!");
			}
			
			  GovdocDealVO dealVo=new GovdocDealVO(); 
			  dealVo.setComment(comment);
			  dealVo.setSummary(summary); 
			  dealVo.setAffairId(newAffair.getId());
			  Map<String, Object> pishiParams=new HashMap<String, Object>();
			  pishiParams.put("pishiName", pishiName); 
			  pishiParams.put("pishiNo",pishiInputObject.getPishiNo()); 
			  pishiParams.put("pishiyear",pishiInputObject.getPishiYear()); 
			  pishiParams.put("proxyDate",pishiInputObject.getPishiDate()); 
			  dealVo.setPishiParams(pishiParams);
			  Long pishiNoId = govdocPishiManager.saveLeaderPishiNo(dealVo); 
			  if(pishiNoId!=null) {
				  pishiInputObject.setPishiNoId(pishiNoId);
			  }
			 
		}
		//保存一份假数据做页面展示
		govdocCommentManager.saveOpinionFromPishi(summary, newAffair, comment, pishiInputObject);
		return comment;
		
	}
	private CtpAffair saveAffair(CtpAffair affair, PishiDeal pishiInputObject) throws BusinessException {
		CtpAffair pishiAffair;
		try {
			pishiAffair = (CtpAffair) affair.clone();
			if(pishiInputObject.getAffairId() != null){
				pishiAffair.setId(pishiInputObject.getAffairId());
			}
			else{
				pishiAffair.setNewId();
			}

			pishiAffair.setMemberId(pishiInputObject.getPishiUser());
			pishiAffair.setState(StateEnum.col_pending.getKey());
			pishiAffair.setCompleteTime(new Date());
			pishiAffair.setSubState(SubStateEnum.col_normal.getKey());
			//affairManager.save(pishiAffair);
			return pishiAffair;
		} catch (Exception e) {
			throw new BusinessException(e);
		}
	}
	
	private PishiInputObject getPishiInputObject(Map<String, String> param) {
		String pishiUser = param.get("pishiUser");
		if (Strings.isEmpty(pishiUser)) {
			return null;
		}

		PishiInputObject object = new PishiInputObject();
		try {
			object.setPishiDate(DateUtil.parseTimestamp(param.get("pishiDate"), "yyyy-MM-dd HH:mm"));
		} catch (ParseException e) {
			e.printStackTrace();
		}
		object.setPishiUser(Long.valueOf(pishiUser.substring(pishiUser.indexOf("|") + 1)));
		object.setInputUserId(AppContext.currentUserId());
		object.setPishiField(param.get("pishiField"));
		object.setPishiOpinion(param.get("opinion"));
		object.setPishiYear(param.get("pishiYear"));
		object.setPishiNo(param.get("pishiNo"));
		object.setPolicy(param.get("policy"));
		object.setPolicyName(param.get("policyName"));
		object.setAttitude(param.get("attitude"));
		object.setAttitudeCode(param.get("attitudeCode"));
		object.setPostInfo(param.get("postInfo"));
		object.setNum(param.get("num"));
		return object;
	}
	
	private PishiDeal getPishiDeal(Map<String, String> param) {
		String pishiUser = param.get("pishiUser");
		if (Strings.isEmpty(pishiUser)) {
			return null;
		}
		PishiDeal object = new PishiDeal();
		try {
			object.setPishiDate(DateUtil.parseTimestamp(param.get("pishiDate"), "yyyy-MM-dd HH:mm:ss"));
		} catch (ParseException e) {
			e.printStackTrace();
		}
		if(Strings.isNotBlank(param.get("id"))) {
			object.setId(Long.valueOf(param.get("id")));
		}
		object.setPishiUser(Long.valueOf(pishiUser.substring(pishiUser.indexOf("|") + 1)));
		object.setInputUserId(AppContext.currentUserId());
		object.setInputUserName(AppContext.getCurrentUser().getName());
		object.setPishiOpinion(param.get("opinion"));
		object.setPishiYear(param.get("pishiYear"));
		object.setPishiNo(param.get("pishiNo"));
		object.setPolicy(param.get("policy"));
		object.setPolicyName(param.get("policyName"));
		object.setAttitude(param.get("attitude"));
		object.setAttitudeCode(param.get("attitudeCode"));
		object.setPostInfo(param.get("postInfo"));
		object.setNum(Integer.valueOf(param.get("num")));
		return object;
	}
	@AjaxAccess
	public String savePishiDealInfo(List<Map<String, String>> param,Long summaryId,List<String> affairIds,Map<String,String> affairIdPishiMap) throws BusinessException {
		Long userId = AppContext.getCurrentUser().getId();
		List<PishiDeal> pishiDealList = pishiDealDao.findBy("summaryId", summaryId);
		long maxSortId = 0;
		for (Map<String, String> map : param) {
			String pishiUser = map.get("pishiUser");
			PishiDeal pishiDeal = null;
			for(PishiDeal deal:pishiDealList) {
				if(pishiUser.split("\\|")[1].equals(String.valueOf(deal.getPishiUser()))&&String.valueOf(deal.getNum()).equals(map.get("num"))) {
					pishiDeal = deal;
					continue;
				}
			}
			if(pishiDeal == null) {
				pishiDeal = getPishiDeal(map);
				if(map.containsKey("nodeId")){
					pishiDeal.setNodeId(Long.valueOf(map.get("nodeId")));
				}
				pishiDeal.setPostInfo(map.get("postInfo"));
				pishiDeal.setSummaryId(summaryId);
				pishiDeal.setId(UUIDLong.longUUID());
				if(pishiDeal.getSortId() == null)
				{
					maxSortId = maxSortId + 1;
					pishiDeal.setSortId(maxSortId);
				}
				pishiDealDao.save(pishiDeal);
				continue;
			}
			//代录批示点保存时还没有nodeId
			if(map.containsKey("nodeId")){
				pishiDeal.setNodeId(Long.valueOf(map.get("nodeId")));
			}
			pishiDeal.setPostInfo(map.get("postInfo"));
			pishiDealDao.update(pishiDeal);
		}

		
//		if(pishiDealCacheMap.contains(summaryId+userId+"")) {
//			pishiDealCacheMap.remove(summaryId+userId+"");
//		}
		//代录批示点保存时还没有nodeId,此处不用删affair
//		boolean isDailuSubmit = false;
//		for (Map<String, String> map : param) {
//			if(map.containsKey("nodeId")){
//				isDailuSubmit = true;
//			}
//		}
//		if (isDailuSubmit) {
		for(String affairId : affairIds) {
			edocOpinionDao.deleteDealOpinionByAffairId(Long.valueOf(affairId));
		}
		//}
		//pishiDealCacheMap.put(summaryId+userId+"", pishiDealList);
		return "sucess";
	}

	@Override
	public void dealLeaderNode(Long summaryId, Long userId) throws BusinessException {
		List<PishiDeal> list = pishiDealDao.findBy("summaryId", summaryId);
		PishiDeal deal = null;
		CtpAffair affair = null;
		if(list!=null&&!list.isEmpty()) {
			for(PishiDeal pishi:list) {
				if(!userId.equals(pishi.getInputUserId())) {
					continue;
				}
				List<CtpAffair> affairs = affairManager.getAffairsByNodeId(pishi.getNodeId());
				if(affairs!=null&&affairs.size()>0) {
					affair = affairs.get(0);
					deal = pishi;
				}
			}
		}
		if(deal!=null&&affair!=null) {
			EdocSummary summary = null;
			String postInfo = deal.getPostInfo();
			Comment opinion = new Comment();
			opinion.setAffairId(affair.getId());
			opinion.setContent(deal.getPishiOpinion());
			opinion.setCreateId(affair.getMemberId());
			opinion.setCtype(Comment.CommentType.comment.getKey());// 批处理的时候设置类型为评论
			opinion.setClevel(1);
			opinion.setPid(0L);
			opinion.setModuleType(4);
			opinion.setModuleId(summaryId);
			opinion.setRelateInfo("[]");
			opinion.setExtAtt1(deal.getAttitude());
			opinion.setExtAtt4(deal.getAttitudeCode());

			opinion.setCreateDate(deal.getPishiDate());
			if(Strings.isNotBlank(postInfo)) {
				String[] orgInfos = postInfo.split("\\|");
				if(orgInfos != null && orgInfos.length >=2) {
					Long accountId = Long.parseLong(orgInfos[0]);
					Long departmentId = Long.parseLong(orgInfos[1]);
					Long postId = Long.parseLong(orgInfos[2]);
					opinion.setAccountId(accountId);
					opinion.setDepartmentId(departmentId);
					opinion.setPostId(postId);
				}
			}else {
				opinion.setAccountId(affair.getMatchAccountId());
				opinion.setDepartmentId(affair.getMatchDepartmentId());
				opinion.setPostId(affair.getMatchPostId());
			}
			try {
				summary = govdocSummaryManager.getSummaryById(summaryId);
				GovdocDealVO dealVo = new  GovdocDealVO();
				GovdocNewHelper.fillBatchFinishParam(dealVo, summary, affair);
				dealVo.setCurrentDate(DateUtil.currentDate());
				V3xOrgMember dealMember = orgManager.getMemberById(userId);
				User dealUser = new User();
				dealUser.setAccountId(dealMember.getOrgAccountId());
				dealUser.setDepartmentId(dealMember.getOrgDepartmentId());
				dealUser.setId(dealMember.getId());
				dealUser.setName(dealMember.getName());
				dealVo.setCurrentUser(dealUser);
				dealVo.setCurrentUser(dealUser);
				
				// 流程分支匹配数据
				dealVo.setConditionsOfNodes("");
				
				dealVo.setFrom("batch");
				//封装节点权限
				//govdocPubManager.fillFinishPermisssion(dealVo);//判断是否有签收
				dealVo.setComment(opinion);
				if(summary.getTempleteId() != null) {
					CtpTemplate template = templateManager.getCtpTemplate(summary.getTempleteId());
					dealVo.setTemplate(template);
				}
				dealVo.setLeaderPishiFlag("2");
				dealVo.setFlowPermAccountId(affair.getOrgAccountId());
				dealVo.setHandType(ColHandleType.finish);
				//保存领导批示
				Map<String ,Long> map = new HashMap<String, Long>();
				map.put("leaderId", deal.getPishiUser());
				List<GovdocLeaderSerialShortname> pishiSerialNoConfig = govdocPishiDao.getGovdocLSSs(null, map);
				
				String pishiName=null;
				if(pishiSerialNoConfig!=null&&!pishiSerialNoConfig.isEmpty()){
					pishiName=pishiSerialNoConfig.get(0).getShortName();
				}
				Map<String, Object> pishiParams = new HashMap<String, Object>();
				if(Strings.isNotBlank(pishiName)) {
					pishiParams.put("pishiName", pishiName);
					pishiParams.put("pishiNo", Integer.valueOf(deal.getPishiNo()));
					pishiParams.put("pishiyear", deal.getPishiYear());
					pishiParams.put("proxyDate", deal.getPishiDate());
					//if (i==list.size()) {
					//	pishiParams.put("pishiIsLast", true);
					//}
					dealVo.setPishiParams(pishiParams);
					govdocPishiManager.emptyPishiNoByAffairId(deal.getAffairId(), pishiName);
				}
				try {
					Thread.sleep(800);
				}catch(Exception e) {
					
				}
				pishiDealDao.delete(deal.getId());
				govdocManager.transFinishWorkItem(dealVo);
				//pishiDealDao.delete(deal.getId());
			}catch(Exception e) {
				LOGGER.error("代领导批示处理节点出错",e);
			}
			
			
		}
	}

	@Override
	public Map<String,Object> getPostByMemberId(Long memberId) throws BusinessException {
		//设置当前处理的的岗位
		Map<String,Object> map = new HashMap<String, Object>();
		List<MemberPost> postList = new ArrayList<MemberPost>();
		V3xOrgMember currentMember = orgManager.getMemberById(memberId);
		MemberPost mainPost = MemberPost.createMainPost(currentMember);
		postList.add(mainPost);
		List<MemberPost> secondPostList = currentMember.getSecond_post();
		List<MemberPost> concurrentPostList = currentMember.getConcurrentPost();
		if(concurrentPostList!= null && !concurrentPostList.isEmpty())
		{
			postList.addAll(concurrentPostList);
		}
		if(secondPostList!= null && !secondPostList.isEmpty())
		{
			postList.addAll(secondPostList);
		}

		List<MemberPostVO> memberPostVOList = new ArrayList<MemberPostVO>();
		for(MemberPost tempPost : postList)
		{
			Long tempAccountId = tempPost.getOrgAccountId();
			Long tempDeptId = tempPost.getDepId();
			Long tempPostId = tempPost.getPostId();
			String tempAccountName = orgManager.getAccountById(tempAccountId).getShortName();
			String tempDeptName = "没有设置部门";
			V3xOrgDepartment depart =  orgManager.getDepartmentById(tempDeptId);
			if(depart != null)
			{
				tempDeptName  = depart.getName();
			}

			String tempPostName = "没有设置岗位";
			V3xOrgPost post = orgManager.getPostById(tempPostId);
			if(post!= null)
			{
				tempPostName = post.getName();
			}
			MemberPostVO memberPostVO = new MemberPostVO(tempAccountName,tempDeptName,tempPostName,tempPost);
			memberPostVOList.add(memberPostVO);
			if(tempPost.getOrgAccountId().equals(AppContext.getCurrentUser().getAccountId()))
			{
				
				map.put("mainPost",memberPostVO);
			}
		}
		map.put("memberPostVOList",memberPostVOList);
		return map;
	}

	@Override
	@AjaxAccess
	public void deleteOpinion(List<String> affairIds,List<Map<String,String>> param,Long summaryId) throws BusinessException {
//		Long userId = AppContext.getCurrentUser().getId();
//		List<PishiDeal> list = pishiDealCacheMap.get(summaryId+userId+"");
//		for(PishiDeal deal:list) {
//			if(pishiDealAffairCacheMap.contains(deal.getPishiUser() +""+ summaryId + deal.getNum() + "")) {//pishiUserId+summaryId+""+pishiInputObject.getNum()
//				affairIds.remove(pishiDealAffairCacheMap.get(deal.getPishiUser() +""+ summaryId + deal.getNum() + ""));
//			}
//		}
		for(String affairId : affairIds) {
			//pishiDealAffairCacheMap.
			edocOpinionDao.deleteDealOpinionByAffairId(Long.valueOf(affairId));
		}
		
	}

	@Override
	public List<PishiDeal> getDealList(Long summaryId) throws BusinessException {
    	if(Long.valueOf(summaryId)==null) {
			return null;
		}
    	List<PishiDeal> opinionlist = pishiDealDao.getPishiDealBySummaryId(summaryId);
		if(opinionlist!=null&&opinionlist.size()>0) {
			return opinionlist;
		}
		return null;
	}

	public PishiDealDao getPishiDealDao() {
		return pishiDealDao;
	}

	public void setPishiDealDao(PishiDealDao pishiDealDao) {
		this.pishiDealDao = pishiDealDao;
	}

}
